Scriptname SLAdventures_CrimeScanScript extends ActiveMagicEffect 

Event OnEffectStart(Actor akTarget, Actor akCaster)
	If (CheckConditions(akTarget, akCaster) == True)
		SLAdventures_CrimeReporters.AddForm(akTarget)
	EndIf
EndEvent 

Bool Function CheckConditions(Actor akTarget, Actor akCaster)

	If (SLAdventures_ValidCrimeFactions.HasForm(akTarget.GetCrimeFaction()) == False) 
		return False
	EndIf

	If (akTarget.IsInFaction(CurrentFollowerFaction) == True)
		return False
	EndIf
	
	If (akCaster.IsDetectedBy(akTarget) == False)
		return False
	EndIf 
	
	If (akTarget.IsHostileToActor(akCaster) == True)
		return False
	EndIf
	
	If (akTarget.IsInFaction(SLAdventures_CurrentPartnerFaction) == True)
		return False
	EndIf
	
	If (akTarget.IsInFaction(SLAdventures_CrimeSafeList) == True)
		return False
	EndIf
	
	If (Crime.bOnlyGuardsReport == True) && (akTarget.IsGuard() == False)
		return False
	EndIf
		
	If (Sexlab.GetGender(akTarget) == 0) && (Crime.iArousalThresholdMale != 0) && (Aroused.GetActorArousal(akTarget) > Crime.iArousalThresholdMale)
		return False
	ElseIf (Sexlab.GetGender(akTarget) == 1) && (Crime.iArousalThresholdFemale != 0) && (Aroused.GetActorArousal(akTarget) > Crime.iArousalThresholdFemale)
		return False 
	EndIf
	
	If (Utility.RandomInt(1,100) > Crime.iChanceReported) 
		return False
	EndIf
	
	return True 
	
EndFunction 

SLAdventures_CrimeScript Property Crime Auto 
SexLabFramework Property Sexlab Auto 
slaFrameworkscr Property Aroused Auto 
Faction Property SLAdventures_CurrentPartnerFaction Auto 
Faction Property SLAdventures_CrimeSafeList Auto 
Faction Property CurrentFollowerFaction Auto 
FormList Property SLAdventures_CrimeReporters Auto 
FormList Property SLAdventures_ValidCrimeFactions Auto 
