Scriptname SLAdventures_CrimeScript extends Quest 

;Events

Event OnUpdate()

	If (RapeController == none)
		RapeController = SLAdventures_GangRapeController.GetInstance()
	EndIf
	If (ProximityRape == none)
		ProximityRape = SLAdventures_ProximityRapeScript.GetInstance()
	EndIf

	If (bShowDebugMessages == True) 
		Debug.Notification("Crime check.")
	EndIf
	If (CheckBaseConditions() == True)
		If (bShowDebugMessages == True) 
			Debug.Notification("Conditions are met.")
		EndIf
		Int[] Crimes = GetCommittedCrimes()
		If (bShowDebugMessages == True) 
			Debug.Notification("Crimes: " + Crimes[0] + "," + Crimes[1] + "," + Crimes[2] + "," + Crimes[3] + "," + Crimes[4] + "," + Crimes[5] + "," + Crimes[6] + ".")
		EndIf
		SLAdventures_CrimeReporters.Revert()
		SLAdventures_CrimeScanSpell.Cast(Player)
		;debug.notification("CrimeScan.Cast")
		Utility.Wait(2.0)
		If (SLAdventures_MagicCrimeReporters.GetSize() > 0)
			Int size = SLAdventures_MagicCrimeReporters.GetSize()
			While (size >= 0)
				SLAdventures_CrimeReporters.AddForm(SLAdventures_MagicCrimeReporters.GetAt(size))
				size -= 1
			EndWhile
		EndIf
		If (SLAdventures_CrimeReporters.GetSize() > 0) 
			If (bShowDebugMessages == True) 
				Debug.Notification("Detected by at least one valid NPC.")
				Debug.Notification("Reporting Crimes to " + CrimeLaws[SLA_Utility.GetCurrentCrimeFactionAsInt(Player)].CrimeFaction.GetName())
			EndIf
			Int TotalBounty = CrimeLaws[SLA_Utility.GetCurrentCrimeFactionAsInt(Player)].Report(Crimes)
			If (TotalBounty > 0) && (bReportersCanRape == True) && (RapeController.IsPossible() == "") \
			&& (SLA_Utility.GetHoursPassed(ProximityRape.fLastRape) >= ProximityRape.fRapeCoolDown)
				Int index = 0
				Actor akActor 
				While (index < SLAdventures_CrimeReporters.GetSize()) && (index < 26)
					akActor = SLAdventures_CrimeReporters.GetAt(index) as Actor
					If (ProximityRape.IsValidAttacker(akActor) == True)
						SLAdventures_CrimeRapists.AddForm(akActor)
					EndIf
					index += 1
				EndWhile
				If (SLAdventures_CrimeRapists.GetSize() >= iMinimumCrimeRapists)
				;Todo disallow post rape events, but trigger the jail event after the rape if a guard reported the player 
					RapeController.GangRape(SLAdventures_CrimeRapists)
					SLAdventures_CrimeRapists.Revert()
				EndIf
			Else
				If (bShowDebugMessages == True) 
					Debug.Notification("Crime Rape failed because ")
					If (TotalBounty <= 0) 
						Debug.Notification("no bounty was received.")
					ElseIf (bReportersCanRape == False) 
						Debug.Notification("Crime Rape is turned off.")
					ElseIf (RapeController.IsPossible() != "") 
						Debug.Notification(RapeController.IsPossible() + ".")
					EndIf
				EndIf
			EndIf 
		EndIf 
		SLAdventures_MagicCrimeReporters.Revert()
	EndIf
	RegisterForSingleUpdate(fInterval)
	
EndEvent

;/Event AddCustomBounty(Int iAmount, Bool bApplyImmediately)
	AddBounty(iAmount)
	If (bApplyImmediately == True) 
		ApplyBounty() 
	EndIf
EndEvent/;

;Functions 

Function SpellCast(Form akSpell) 
	SLAdventures_MagicCrimeScanSpell.Cast(Player)
EndFunction 

Bool Function CheckBaseConditions()

	If (bEnabled == False)
		If (bShowDebugMessages == True) 
			Debug.Notification("Condition not met: Crime disabled.")
		EndIf
		return False
	EndIf 
	
	If ((StorageUtil.HasIntValue(Player, "xpoPCInJail") == True) && (StorageUtil.GetIntValue(Player, "xpoPCInJail") == 1)) \
	|| ((StorageUtil.HasIntValue(Player, "xpoPCArrested") == True) && (StorageUtil.GetIntValue(Player, "xpoPCArrested") == 1)) \
	|| ((StorageUtil.HasIntValue(Player, "xpoPCArrestStart") == True) && (StorageUtil.GetIntValue(Player, "xpoPCArrestStart") == 1))
		If (bShowDebugMessages == True) 
			Debug.Notification("Condition not met: Player is imprisoned in Prison Overhaul.")
		EndIf
		return False
	EndIf
	
	If (DLCModsComp.bDDAssetsIsLoaded == True) && (bNoReportWhenCollared == True) && (Player.WornHasKeyword(DLCModsComp.zad_DeviousCollar) == True)
		If (bShowDebugMessages == True) 
			Debug.Notification("Condition not met: Player is collared.")
		EndIf
		return False
	EndIf
	
	If (SLA_Utility.bDDHelplessSuspend == True)
		If (bShowDebugMessages == True) 
			Debug.Notification("Condition not met: Deviously Helpless Suspend.")
		EndIf
		return False
	EndIf
	
	If (PlayerSexTracker.fAfterSex != 0.0)
		If (bShowDebugMessages == True) 
			Debug.Notification("Condition not met: After Sex grace period.")
		EndIf
		return False
	EndIf
	
	If (SLA_Utility.GetCurrentCrimeFaction(Player as ObjectReference) == none)
		If (bShowDebugMessages == True) 
			Debug.Notification("Condition not met: Invalid location.")
		EndIf
		return False
	EndIf
	
	If ((RapeController.IsIdle() == False) && (bReportsAreValidWhenRaped == False))
		If (bShowDebugMessages == True) 
			Debug.Notification("Condition not met: Player is being gangraped.")
		EndIf
		return False
	EndIf
	
	If ((PlayerSexTracker.bIsVictim == True) && (bReportsAreValidWhenRaped == False))
		If (bShowDebugMessages == True) 
			Debug.Notification("Condition not met: Player is being raped.")
		EndIf
		return False
	EndIf
	
	Location PlayerLocation = (Player as ObjectReference).GetCurrentLocation()
	If (Player.IsInInterior() == False)
		;debug.notification("Base Condition success: Player is outside.")
		return True
	ElseIf (SLA_Utility.IsTavern(PlayerLocation) == True)
		If (bShowDebugMessages == True) && (bInnsArePublic == False)
			Debug.Notification("Condition not met: Player is inside a non-public interior.")
		EndIf
		Return bInnsArePublic
	ElseIf (SLA_Utility.IsStore(PlayerLocation) == True)
		If (bShowDebugMessages == True) && (bStoresArePublic == False)
			Debug.Notification("Condition not met: Player is inside a non-public interior.")
		EndIf
		Return bStoresArePublic
	ElseIf (SLA_Utility.IsCastle(PlayerLocation) == True)
		If (bShowDebugMessages == True) && (bCastlesArePublic == False)
			Debug.Notification("Condition not met: Player is inside a non-public interior.")
		EndIf
		Return bCastlesArePublic
	ElseIf (SLA_Utility.IsTemple(PlayerLocation) == True)
		If (bShowDebugMessages == True) && (bTemplesArePublic == False)
			Debug.Notification("Condition not met: Player is inside a non-public interior.")
		EndIf
		Return bTemplesArePublic
	ElseIf (SLA_Utility.IsGuild(PlayerLocation) == True)
		If (bShowDebugMessages == True) && (bGuildsArePublic == False)
			Debug.Notification("Condition not met: Player is inside a non-public interior.")
		EndIf
		Return bGuildsArePublic	
	Else
		If (bShowDebugMessages == True) 
			Debug.Notification("Condition not met: Player is inside a non-public interior.")
		EndIf
		Return False 
	EndIf
	
	;debug.notification("Crime Base Conditions True")
	return True 
	
EndFunction 

Int[] Function GetCommittedCrimes() 
	
	;debug.notification("GetCommittedCrimes()")
	Int[] Crimes = new Int[7]
	
	;Nudity
	If (IsNaked(MCM.iNakedRule) == True)
		Crimes[0] = CRIME_NUDE_IN_PUBLIC
	Else
		Crimes[0] = CRIME_NOT_NUDE
	EndIf
	
	;Cum
	If (ArousedScanner.IsCoveredInCum(Player) == True)
		Crimes[1] = CRIME_COVERED_IN_CUM
	Else
		Crimes[1] = 0
	EndIf
	
	;Sex
	If (PlayerSexTracker.iHasSex == 2)
		Crimes[2] = CRIME_MASTURBATING
	ElseIf (PlayerSexTracker.iHasSex == 3)
		Crimes[2] = CRIME_SEX
	ElseIf (PlayerSexTracker.iHasSex == 4)
		Crimes[2] = CRIME_HOMO
	ElseIf (PlayerSexTracker.iHasSex == 5)
		Crimes[2] = CRIME_BEAST
	Else
		Crimes[2] = 0
	EndIf
	
	;Armed
	If (bSpellsCountAsArmed == True) && ((Player.GetEquippedSpell(1) != none) || (Player.GetEquippedSpell(0) != none))
		Crimes[3] = CRIME_ARMED
	Else
		Int PlayerEquippedItem = Player.GetEquippedItemType(1)
		If ((PlayerEquippedItem == 0) || (PlayerEquippedItem == 9) || (PlayerEquippedItem == 11))
			PlayerEquippedItem = Player.GetEquippedItemType(0)
			If ((PlayerEquippedItem == 0) || (PlayerEquippedItem == 9) || (PlayerEquippedItem == 11))
				Crimes[3] = 0
			Else
				Crimes[3] = CRIME_ARMED
			EndIf
		Else
			Crimes[3] = CRIME_ARMED
		EndIf
	EndIf
	If (Crimes[3] == 0)
		;Player.GetItemCount() is bugged and does not detect weapons
		Int Items = Player.GetNumItems()
		Form FoundWeapon = none
		Form FoundForm
		While (Items > 0) && (FoundWeapon == none)
			FoundForm = Player.GetNthForm(Items - 1)
			If (FoundForm.HasKeyword(VendorItemWeapon))
				FoundWeapon = FoundForm
			EndIf
		Items -= 1
		EndWhile
		If (FoundWeapon != none) 
			Crimes[3] = CRIME_HAS_WEAPONS
		EndIf
	EndIf
	If (Player.IsInCombat()) 
		If (Crimes[3] == CRIME_ARMED)
			Crimes[3] = CRIME_ARMED_DURING_COMBAT
		ElseIf (Crimes[3] == CRIME_HAS_WEAPONS) 
			Crimes[3] = CRIME_HAS_WEAPONS_DURING_COMBAT
		EndIf
	EndIf
	
	;Night
	float fTime = SLA_Utility.GetTimeOfDay()
	If ((fTime > SLA_Utility.fDusk) || (fTime < SLA_Utility.fDawn))
		Crimes[4] = CRIME_OUT_AT_NIGHT
	Else 
		Crimes[4] = 0
	EndIf 
	
	;Collared
	If (DLCModsComp.bDDAssetsIsLoaded == True) && (Player.WornHasKeyword(DLCModsComp.zad_DeviousCollar) == True)
		Crimes[5] = CRIME_COLLARED
	Else
		Crimes[5] = CRIME_NOT_COLLARED
	EndIf
	
	;Magic
	If (SLAdventures_MagicCrimeReporters.GetSize() > 0) 
		Crimes[6] = CRIME_USED_MAGIC
	Else 
		Crimes[6] = 0
	EndIf
	
	return Crimes
	
EndFunction 

Bool Function HasValidCrime(Int[] Crimes) 

	Int index = 0
	While (index < Crimes.Length) 
		If (Crimes[index] > 0)
			return True
		EndIf
	index += 1
	EndWhile
	return False

EndFunction 

Bool Function IsNaked(Int iNakedRule)
	
	If (iNakedRule == 0)           			;Aroused nudity             
        If (Aroused.IsActorNaked(Player))
            If (Player.GetWornForm(4) == none) || (bTreatEroticArmorsAsNaked == True) || (Player.GetWornForm(4).HasKeyword(EroticArmor) == False)
                return True
            Else
                return False
			EndIf
        Else 
            return False
        EndIf
	ElseIf (Player.GetWornForm(4) == none)	;If nothing is in the main slot

		If (iNakedRule == 1)
			return True
		Else 
			
			bool ExposedChest = False
			bool ExposedCrotch = False
			
			If (Player.GetWornForm(65536) == none && Player.GetWornForm(67108864) == none)
				ExposedChest = True
			EndIf
			If (Player.GetWornForm(524288) == none && Player.GetWornForm(4194304) == none)
				ExposedCrotch = True
			EndIf

			If (iNakedRule == 2 && ExposedChest == True)
				return True
			ElseIf (iNakedRule == 3 && ExposedCrotch == True)
				return True
			ElseIf (iNakedRule == 4 && ExposedChest == True && ExposedCrotch == True)
				return True
			ElseIf (iNakedRule == 5 && (ExposedChest == True || ExposedCrotch == True))
				return True
			Else 
				return False
			EndIf
		EndIf
	EndIf
	
EndFunction  

Function SaveMCMOptions(String FileName)

	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "InnsArePublic", bInnsArePublic)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "StoresArePublic", bStoresArePublic)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "CastlesArePublic", bCastlesArePublic)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "TemplesArePublic", bTemplesArePublic)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "GuildsArePublic", bGuildsArePublic)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "SpellsCountAsArmed", bSpellsCountAsArmed)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "CrimeEnabled", bEnabled)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, "CrimeInterval", fInterval)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "ReportsAreValidIfRaped", bReportsAreValidWhenRaped)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "ReportersCanRape", bReportersCanRape)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "OnlyGuardsReport", bOnlyGuardsReport)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "NoReportWhenCollared", bNoReportWhenCollared)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "ArousalThresholdFemale", iArousalThresholdFemale)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "ArousalThresholdMale", iArousalThresholdMale)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "ChanceReported", iChanceReported)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "NotifyLawsChange", bNotifyLawsChange)

EndFunction  

Function LoadMCMOptions(String FileName) 

	bInnsArePublic = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "InnsArePublic")
	bStoresArePublic = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "StoresArePublic")
	bCastlesArePublic = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "CastlesArePublic")
	bTemplesArePublic = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "TemplesArePublic")
	bGuildsArePublic = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "GuildsArePublic")
	bSpellsCountAsArmed = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "SpellsCountAsArmed")
	bEnabled = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "CrimeEnabled")
	If (bEnabled == True)
		RegisterForSingleUpdate(fInterval)
	Else
		UnregisterForUpdate()
	EndIf
	fInterval = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, "CrimeInterval", 5.0, 15.0, 0.1)
	bReportsAreValidWhenRaped = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "ReportsAreValidIfRaped")
	bReportersCanRape = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "ReportersCanRape")
	bOnlyGuardsReport = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "OnlyGuardsReport")
	bNoReportWhenCollared = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "NoReportWhenCollared")
	iArousalThresholdFemale = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "ArousalThresholdFemale", 0, 100)
	iArousalThresholdMale = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "ArousalThresholdMale", 0, 100)
	iChanceReported = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "ChanceReported", 0, 100)
	bNotifyLawsChange = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "NotifyLawsChange")

EndFunction 

;Variables and Properties - no functions after this line  
	
;Properties

Actor Property Player Auto 
Keyword Property VendorItemWeapon Auto 
Keyword Property WeapTypeSword Auto 

SLAdventures_MCM_Script Property MCM Auto 
slaMainScr Property Aroused Auto 
SLAdventures_Utility Property SLA_Utility Auto 
SLAdventures_SexDiary Property SLA_SexDia Auto 
SLAdventures_DLCAndModCompScript Property DLCModsComp Auto  
SLAdventures_CrimeLawsScript[] Property CrimeLaws Auto 
SLAdventures_PlayerArousedScanner Property ArousedScanner Auto 
SLAdventures_PlayerSexTracker Property PlayerSexTracker Auto 
SLAdventures_GangRapeController Property RapeController Auto 
SLAdventures_ProximityRapeScript Property ProximityRape Auto 

Spell Property SLAdventures_CrimeScanSpell Auto 
Spell Property SLAdventures_MagicCrimeScanSpell Auto 

FormList Property SLAdventures_CrimeReporters Auto 
FormList Property SLAdventures_MagicCrimeReporters Auto 
FormList Property SLAdventures_CrimeRapists Auto
FormList Property SLAdventures_ValidCrimeFactions Auto 
GlobalVariable Property SLAdventures_PlayerIsCoveredInCum Auto 
Keyword Property EroticArmor Auto 

Bool Property bInnsArePublic = True Auto Hidden
Bool Property bStoresArePublic = True Auto Hidden
Bool Property bCastlesArePublic = True Auto Hidden
Bool Property bTemplesArePublic = True Auto Hidden
Bool Property bGuildsArePublic = True Auto Hidden
Bool Property bSpellsCountAsArmed = False Auto Hidden 
Bool Property bShowDebugMessages = False Auto Hidden 

Bool Property bEnabled = True Auto Hidden
float Property fInterval = 6.00 Auto Hidden
bool Property bReportsAreValidWhenRaped = False Auto Hidden
Bool Property bReportersCanRape = True Auto Hidden 
Bool Property bOnlyGuardsReport = False Auto Hidden 
Bool Property bNoReportWhenCollared = False Auto Hidden 
Int Property iArousalThresholdFemale = 100 Auto Hidden 
Int Property iArousalThresholdMale = 100 Auto Hidden 
Int Property iChanceReported = 50 Auto Hidden
Bool Property bNotifyLawsChange = False Auto Hidden 
Bool Property bTreatEroticArmorsAsNaked = True Auto Hidden 
Int Property iMinimumCrimeRapists = 1 Auto Hidden 

;Read-Only Properties 
Int Property CRIME_NUDE_IN_PUBLIC = 10 AutoReadOnly
Int Property CRIME_NOT_NUDE = 11 AutoReadOnly
Int Property CRIME_COVERED_IN_CUM = 20 AutoReadOnly 
Int Property CRIME_MASTURBATING = 30 AutoReadOnly 
Int Property CRIME_SEX = 40 AutoReadOnly 
Int Property CRIME_HOMO = 50 AutoReadOnly 
Int Property CRIME_BEAST = 60 AutoReadOnly 
Int Property CRIME_ARMED = 70 AutoReadOnly 
Int Property CRIME_HAS_WEAPONS = 71 AutoReadOnly 
Int Property CRIME_ARMED_DURING_COMBAT = 72 AutoReadOnly 
Int Property CRIME_HAS_WEAPONS_DURING_COMBAT = 73 AutoReadOnly 
Int Property CRIME_OUT_AT_NIGHT = 80 AutoReadOnly 
Int Property CRIME_COLLARED = 90 AutoReadOnly 
Int Property CRIME_NOT_COLLARED = 91 AutoReadOnly 
Int Property CRIME_USED_MAGIC = 100 AutoReadOnly 

;Deprecated
;0.71

SLAdventures_RapeScript Property SLA_RapeScript Auto
