Scriptname SLAdventures_DLCAndModCompScript extends Quest  
;Check for DLCs and Mods and load the appropriate Forms into their respective FormLists and Properties

Event OnUpdate() 

	If (bDDIntegrationIsLoaded == True)
		If (SLAdventures_DDiLoader.IsRunning() == False)
			SLAdventures_DDiLoader.Start()
		EndIf
	Else
		If (SLAdventures_DDiLoader != none)
			SLAdventures_DDiLoader.Stop()
		EndIf
	EndIf
	
	If (bZAPIsLoaded == True)
		If (SLAdventures_ZazLoader.IsRunning() == False)
			SLAdventures_ZazLoader.Start()
		EndIf
	Else
		If (SLAdventures_ZazLoader != none)
			SLAdventures_ZazLoader.Stop()
		EndIf
	EndIf

EndEvent 

Function CheckInstalledDLCs()

	If (Game.GetModByName(Dawnguard) != 255) 
		If (bDawnguardIsLoaded == False)
			bDawnguardIsLoaded = True
			LoadFormsDawnguard()
		EndIf
	Else
		bDawnguardIsLoaded = False
	EndIf 
	
	MCM.DLCOrModInstalled(Dawnguard, bDawnguardIsLoaded)
	SexDiary.DLCOrModInstalled(Dawnguard, bDawnguardIsLoaded)
	
	If (Game.GetModByName(Dragonborn) != 255) 
		If (bDragonbornIsLoaded == False)
			bDragonbornIsLoaded = True
			LoadFormsDragonborn()
		EndIf
	Else
		bDragonbornIsLoaded = False
	EndIf 
	
	SexDiary.DLCOrModInstalled(Dragonborn, bDragonbornIsLoaded)

EndFunction  

Function CheckInstalledMods()
	
	;debug.notification("CheckInstalledMods()")
	
	If (Game.GetModByName(DDAssets) != 255)
		bDDAssetsIsLoaded = True
	Else
		bDDAssetsIsLoaded = False
	EndIf
	
	If (Game.GetModByName(DDIntegration) != 255)
		bDDIntegrationIsLoaded = True
	Else
		bDDIntegrationIsLoaded = False
	EndIf
	
	If (Game.GetModByName(ZAP) != 255)
		bZAPIsLoaded = True
	Else
		bZAPIsLoaded = False
	EndIf
	
	If (Game.GetModByName(SimpleSlavery) != 255)
		bSimpleSlaveryIsLoaded = True
	Else
		bSimpleSlaveryIsLoaded = False
	EndIf
	
	If (Game.GetModByName(POP) != 255)
		bPOPIsLoaded = True
	Else
		bPOPIsLoaded = False
	EndIf
	
	If (Game.GetModByName(RND) != 255)
		bRNDIsLoaded = True
	Else
		bRNDIsLoaded = False
	EndIf
	
	If (Game.GetModByName(SkoomaWhore) != 255)
		bSkoomaWhoreIsLoaded = True
	Else
		bSkoomaWhoreIsLoaded = False
	EndIf
	
	If (Game.GetModByName(iNeeds) != 255)
		biNeedsIsLoaded = True
	Else
		biNeedsIsLoaded = False
	EndIf
	
	If (Game.GetModByName(Defeat) != 255)
		bDefeatIsLoaded = True
	Else
		bDefeatIsLoaded = False
	EndIf
	
	;If (Game.GetModByName(MiniNeeds) != 255)
	;	bMiniNeedsIsLoaded = True
	;Else
	;	bMiniNeedsIsLoaded = False
	;EndIf
	
	If (Game.GetModByName(EFF) != 255)
		bEFFIsLoaded = True
	Else
		bEFFIsLoaded = False
	EndIf
	
	If (Game.GetModByName(UFO) != 255)
		bUFOIsLoaded = True
	Else
		bUFOIsLoaded = False
	EndIf
	
	If (Game.GetModByName(AFT) != 255)
		bAFTIsLoaded = True
	Else
		bAFTIsLoaded = False
	EndIf
		
	LoadFormsMods()
		
EndFunction 

Function LoadFormsDawnguard()

	SLAdventures_DogList.AddForm(Game.GetFormFromFile(0x003D01, Dawnguard))
	SLAdventures_DogList.AddForm(Game.GetFormFromFile(0x018B33, Dawnguard))
	SLAdventures_DogList.AddForm(Game.GetFormFromFile(0x0122B7, Dawnguard))
	SLAdventures_DogList.AddForm(Game.GetFormFromFile(0x018B36, Dawnguard))
	
	SLAdventures_DeerList.AddForm(Game.GetFormFromFile(0x00D0B2, Dawnguard))
	
	SLAdventures_ChaurusList.AddForm(Game.GetFormFromFile(0x015136, Dawnguard))
	SLAdventures_ChaurusList.AddForm(Game.GetFormFromFile(0x0051FB, Dawnguard))
	
	SLAdventures_DragonList.AddForm(Game.GetFormFromFile(0x0117DE, Dawnguard))
	
	SLAdventures_TrollList.AddForm(Game.GetFormFromFile(0x0117F5, Dawnguard))
	SLAdventures_TrollList.AddForm(Game.GetFormFromFile(0x0117F4, Dawnguard))
	
	SLAdventures_DraugrList.AddForm(Game.GetFormFromFile(0x007AF3, Dawnguard))
	SLAdventures_DraugrList.AddForm(Game.GetFormFromFile(0x00894D, Dawnguard))
	
	SLAdventures_SabreCatList.AddForm(Game.GetFormFromFile(0x00D0B6, Dawnguard))
	
	SLAdventures_VampireLordList.AddForm(Game.GetFormFromFile(0x00283A, Dawnguard))
	
	SLAdventures_GargoyleList.AddForm(Game.GetFormFromFile(0x00A2C6, Dawnguard))
	SLAdventures_GargoyleList.AddForm(Game.GetFormFromFile(0x010D00, Dawnguard))
	SLAdventures_GargoyleList.AddForm(Game.GetFormFromFile(0x019D86, Dawnguard))
	
	SLAdventures_DeathHoundList.AddForm(Game.GetFormFromFile(0x00C5F0, Dawnguard))
	SLAdventures_DeathHoundList.AddForm(Game.GetFormFromFile(0x003D02, Dawnguard))
	
EndFunction 

Function LoadFormsDragonborn()

	SLAdventures_DragonList.AddForm(Game.GetFormFromFile(0x02C88C, Dragonborn))
	SLAdventures_DragonList.AddForm(Game.GetFormFromFile(0x01F98F, Dragonborn))
		
	SLAdventures_DraugrList.AddForm(Game.GetFormFromFile(0x01B637, Dragonborn))
	SLAdventures_DraugrList.AddForm(Game.GetFormFromFile(0x02A6FD, Dragonborn))
		
	SLAdventures_GiantList.AddForm(Game.GetFormFromFile(0x014495, Dragonborn))
		
	SLAdventures_RieklingList.AddForm(Game.GetFormFromFile(0x017F44, Dragonborn))
	SLAdventures_RieklingList.AddForm(Game.GetFormFromFile(0x01A50A, Dragonborn))
	SLAdventures_RieklingList.AddForm(Game.GetFormFromFile(0x0179CF, Dragonborn))
	
	Faction RavenRock = Game.GetFormFromFile(0x018279, Dragonborn) as Faction 
	SLAdventures_ValidCrimeFactions.AddForm(RavenRock)
	(RavenRockCrimeLaws as SLAdventures_CrimeLawsScript).CrimeFaction = RavenRock
	SLAdventures_HoldsList.AddForm(Game.GetFormFromFile(0x0143B9, Dragonborn))
	SLAdventures_ValidHoldCapitals.AddForm(Game.GetFormFromFile(0x143B9, Dragonborn))
	
EndFunction

Function LoadFormsMods()

	RegisterForSingleUpdate(3.0)
	
	If (bDDAssetsIsLoaded == True)
		zad_DeviousArmbinder = Game.GetFormFromFile(0xCA3A, DDAssets) as Keyword
		zad_DeviousYoke = Game.GetFormFromFile(0x2C531, DDAssets) as Keyword
		zad_DeviousBlindfold = Game.GetFormFromFile(0x11B1A, DDAssets) as Keyword
		zad_DeviousBoots = Game.GetFormFromFile(0x27F29, DDAssets) as Keyword
		zad_DeviousBelt = Game.GetFormFromFile(0x3330, DDAssets) as Keyword
		zad_DeviousGag = Game.GetFormFromFile(0x7EB8, DDAssets) as Keyword
		zad_DeviousGagPanel = Game.GetFormFromFile(0x1F306, DDAssets) as Keyword
		zad_DeviousCollar = Game.GetFormFromFile(0x3DF7, DDAssets) as Keyword
		zad_PermitOral = Game.GetFormFromFile(0xFAC9, DDAssets) as Keyword
		zad_PermitAnal = Game.GetFormFromFile(0xFACA, DDAssets) as Keyword
		zad_PermitVaginal = Game.GetFormFromFile(0xFACB, DDAssets) as Keyword
	Else
		zad_DeviousArmbinder = none 
		zad_DeviousYoke = none 
		zad_DeviousBlindfold = none
		zad_DeviousBoots = none
		zad_DeviousBelt = none 
		zad_DeviousGag = none
		zad_DeviousGagPanel = none
		zad_DeviousCollar = none
		zad_PermitOral = none
		zad_PermitAnal = none
		zad_PermitVaginal = none
	EndIf
	
	If (bRNDIsLoaded == True)
		RND_Drunk02 = Game.GetFormFromFile(0x1DAB, RND) as Spell
		RND_Drunk03 = Game.GetFormFromFile(0x1DAD, RND) as Spell
	Else
		RND_Drunk02 = none
		RND_Drunk03 = none
	EndIf
	
	If (bSkoomaWhoreIsLoaded == True) 
		SLSW_SuppressionSpell = Game.GetFormFromFile(0x118EE, SkoomaWhore) as Spell
	Else
		SLSW_SuppressionSpell = none 
	EndIf
	
	If (biNeedsIsLoaded == True)
		_SNDrunkSpell = Game.GetFormFromFile(0xC4F2, iNeeds) as Spell
		_SNSKoomaSPell = Game.GetFormFromFile(0x21367, iNeeds) as Spell
	Else
		_SNDrunkSpell = none
		_SNSKoomaSPell = none 
	EndIf
	
	If (bDefeatIsLoaded == True)
		DefeatFaction = Game.GetFormFromFile(0x1D92, Defeat) as Faction
	Else
		DefeatFaction = none 
	EndIf
	
	If (bEFFIsLoaded == True)
		EFFQuest = Game.GetFormFromFile(0xEFF, EFF) as Quest
		EFFAliases = new ReferenceAlias[9] ;EFF supports 99 followers, but we only support 9
		EFFAliases[0] = EFFQuest.GetAlias(1) as ReferenceAlias 
		EFFAliases[1] = EFFQuest.GetAlias(2) as ReferenceAlias 
		EFFAliases[2] = EFFQuest.GetAlias(3) as ReferenceAlias 
		EFFAliases[3] = EFFQuest.GetAlias(4) as ReferenceAlias 
		EFFAliases[4] = EFFQuest.GetAlias(5) as ReferenceAlias 
		EFFAliases[5] = EFFQuest.GetAlias(6) as ReferenceAlias 
		EFFAliases[6] = EFFQuest.GetAlias(7) as ReferenceAlias 
		EFFAliases[7] = EFFQuest.GetAlias(8) as ReferenceAlias 
		EFFAliases[8] = EFFQuest.GetAlias(9) as ReferenceAlias 
	Else
		EFFQuest = none
		EFFAliases = new ReferenceAlias[1] 
	EndIf
	
	If (bAFTIsLoaded == True)
		AFTQuest = Game.GetForm(0x750BA) as Quest ;This is a vanilla quest
		AFTAliases = new ReferenceAlias[6] 
		AFTAliases[0] = AFTQuest.GetAlias(0) as ReferenceAlias ;This is the vanilla follower
		AFTAliases[1] = AFTQuest.GetAlias(2) as ReferenceAlias 
		AFTAliases[2] = AFTQuest.GetAlias(3) as ReferenceAlias 
		AFTAliases[3] = AFTQuest.GetAlias(12) as ReferenceAlias 
		AFTAliases[4] = AFTQuest.GetAlias(11) as ReferenceAlias 
		AFTAliases[5] = AFTQuest.GetAlias(6) as ReferenceAlias 
	Else
		AFTQuest = none
		AFTAliases = new ReferenceAlias[1] 
	EndIf
	
	If (bUFOIsLoaded == True)
		UFOQuest = Game.GetForm(0x750BA) as Quest ;This is a vanilla quest
		UFOAliases = new ReferenceAlias[9] ;UFO supports 15 followers, but we only support 9
		UFOAliases[0] = UFOQuest.GetAlias(0) as ReferenceAlias ;This is the vanilla follower
		UFOAliases[1] = UFOQuest.GetAlias(17) as ReferenceAlias 
		UFOAliases[2] = UFOQuest.GetAlias(16) as ReferenceAlias 
		UFOAliases[3] = UFOQuest.GetAlias(15) as ReferenceAlias 
		UFOAliases[4] = UFOQuest.GetAlias(14) as ReferenceAlias 
		UFOAliases[5] = UFOQuest.GetAlias(13) as ReferenceAlias 
		UFOAliases[6] = UFOQuest.GetAlias(12) as ReferenceAlias 
		UFOAliases[7] = UFOQuest.GetAlias(11) as ReferenceAlias 
		UFOAliases[8] = UFOQuest.GetAlias(10) as ReferenceAlias 
	Else
		UFOQuest = none
		UFOAliases = new ReferenceAlias[1] 
	EndIf
	
EndFunction 

;Helper Functions

Bool Function IsDrunkModLoaded()

	If (bRNDIsLoaded == True)
		return True
	ELseIf (bMiniNeedsIsLoaded == True)
		return True
	ElseIf (biNeedsIsLoaded == True)
		return True
	Else
		return False
	EndIf
	
EndFunction

Bool Function IsPlayerDrunk(Actor Player)

	If (bRNDIsLoaded == True)
		If ((Player.HasSpell(RND_Drunk02) == True) || (Player.HasSpell(RND_Drunk03) == True))
			return True
		Else
			return False
		EndIf
	ElseIf (biNeedsIsLoaded == True)
		return (Player.HasSpell(_SNDrunkSpell) == True)
	Else 
		return False
	EndIf

	
EndFunction

Actor[] Function GetFollowers()
	
	If (bEFFIsLoaded == True) 
		Actor[] Followers = new Actor[9]
		Followers[0] = Follower.GetReference() as Actor
		If (Followers[0] == none)
			Followers[0] = EFFAliases[0].GetReference() as Actor
		EndIf
		Followers[1] = EFFAliases[1].GetReference() as Actor
		Followers[2] = EFFAliases[2].GetReference() as Actor
		Followers[3] = EFFAliases[3].GetReference() as Actor
		Followers[4] = EFFAliases[4].GetReference() as Actor
		Followers[5] = EFFAliases[5].GetReference() as Actor
		Followers[6] = EFFAliases[6].GetReference() as Actor
		Followers[7] = EFFAliases[7].GetReference() as Actor
		Followers[8] = EFFAliases[8].GetReference() as Actor
	ElseIf (bUFOIsLoaded == True)
		Actor[] Followers = new Actor[9]
		Followers[0] = UFOAliases[0].GetReference() as Actor
		Followers[1] = UFOAliases[1].GetReference() as Actor
		Followers[2] = UFOAliases[2].GetReference() as Actor
		Followers[3] = UFOAliases[3].GetReference() as Actor
		Followers[4] = UFOAliases[4].GetReference() as Actor
		Followers[5] = UFOAliases[5].GetReference() as Actor
		Followers[6] = UFOAliases[6].GetReference() as Actor
		Followers[7] = UFOAliases[7].GetReference() as Actor
		Followers[8] = UFOAliases[8].GetReference() as Actor
	ElseIf (bAFTIsLoaded == True)
		Actor[] Followers = new Actor[6]
		Followers[0] = AFTAliases[0].GetReference() as Actor
		Followers[1] = AFTAliases[1].GetReference() as Actor
		Followers[2] = AFTAliases[2].GetReference() as Actor
		Followers[3] = AFTAliases[3].GetReference() as Actor
		Followers[4] = AFTAliases[4].GetReference() as Actor
		Followers[5] = AFTAliases[5].GetReference() as Actor
	Else ;vanilla
		Actor[] Followers = new Actor[1]
		Followers[0] = Follower.GetReference() as Actor
		return Followers
	EndIf
	
EndFunction

;Variables and Properties - no functions after this line 
;Variables

;Read-only Properties

string Property Dawnguard = "Dawnguard.esm" AutoReadOnly Hidden 
string Property Dragonborn = "Dragonborn.esm" AutoReadOnly Hidden 
string Property DDAssets = "Devious Devices - Assets.esm" AutoReadOnly Hidden 
string Property DDIntegration = "Devious Devices - Integration.esm" AutoReadOnly Hidden 
string Property ZAP = "ZaZAnimationPack.esm" AutoReadOnly Hidden 
string Property SimpleSlavery = "SimpleSlavery.esp" AutoReadOnly Hidden 
string Property POP = "xazPrisonOverhaulPatched.esp" AutoReadOnly Hidden 
string Property RND = "RealisticNeedsAndDiseases.esp" AutoReadOnly Hidden 
string Property SkoomaWhore = "SexLabSkoomaWhore.esp" AutoReadOnly Hidden 
string Property iNeeds = "iNeed.esp" AutoReadOnly Hidden 
string Property Defeat = "SexLabDefeat.esp" AutoReadOnly Hidden 
string Property EFF = "EFFCore.esm" AutoReadOnly Hidden 
string Property UFO = "Ultimate Follower Overhaul.esp" AutoReadOnly Hidden 
string Property AFT = "AmazingFollowerTweaks.esp" AutoReadOnly Hidden 

;Properties

Bool Property bDawnguardIsLoaded = False Auto Hidden
Bool Property bDragonbornIsLoaded = False Auto Hidden
Bool Property bSLKidnappedReduxIsLoaded = False Auto Hidden
Bool Property bDDAssetsIsLoaded = False Auto Hidden
Bool Property bDDIntegrationIsLoaded = False Auto Hidden
Bool Property bZAPIsLoaded = False Auto Hidden
Bool Property bSimpleSlaveryIsLoaded = False Auto Hidden
Bool Property bPOPIsLoaded = False Auto Hidden 
Bool Property bRNDIsLoaded = False Auto Hidden
Bool Property bSkoomaWhoreIsLoaded = False Auto Hidden
Bool Property biNeedsIsLoaded = False Auto Hidden 
Bool Property bDefeatIsLoaded = False Auto Hidden 
Bool Property bEFFIsLoaded = False Auto Hidden 
Bool Property bUFOIsLoaded = False Auto Hidden 
Bool Property bAFTIsLoaded = False Auto Hidden 

SLAdventures_MCM_Script Property MCM Auto 
SLAdventures_SexDiary Property SexDiary Auto
SLAdventures_RapeScript Property Rape Auto
SLAdventures_SexCrime Property SexCrime Auto 
Quest Property SLAdventures_DDiLoader Auto   
Quest Property SLAdventures_ZazLoader Auto 
Quest Property RavenRockCrimeLaws Auto 

FormList Property SLAdventures_DogList Auto 
FormList Property SLAdventures_DeerList Auto
FormList Property SLAdventures_ChaurusList Auto 
FormList Property SLAdventures_DragonList Auto 
FormList Property SLAdventures_GiantList Auto 
FormList Property SLAdventures_TrollList Auto  
FormList Property SLAdventures_DraugrList Auto 
FormList Property SLAdventures_SabreCatList Auto 
FormList Property SLAdventures_ValidCrimeFactions Auto
FormList Property SLAdventures_ValidHoldCapitals Auto
FormList Property SLAdventures_HoldsList Auto 

;DLC1
FormList Property SLAdventures_VampireLordList Auto 
FormList Property SLAdventures_GargoyleList Auto
FormList Property SLAdventures_DeathHoundList Auto

;DLC2
FormList Property SLAdventures_RieklingList Auto 

;Devious Devices
Keyword Property zad_DeviousArmbinder Auto Hidden
Keyword Property zad_DeviousYoke Auto Hidden
Keyword Property zad_DeviousBlindfold Auto Hidden
Keyword Property zad_DeviousBelt Auto Hidden
Keyword Property zad_DeviousBoots Auto Hidden 
Keyword Property zad_DeviousGag Auto Hidden 
Keyword Property zad_DeviousGagPanel Auto Hidden 
Keyword Property zad_DeviousCollar Auto Hidden 
Keyword Property zad_PermitOral Auto Hidden 
Keyword Property zad_PermitAnal Auto Hidden 
Keyword Property zad_PermitVaginal Auto Hidden 

;RND
Spell Property RND_Drunk02 Auto Hidden 
Spell Property RND_Drunk03 Auto Hidden 

;Skooma Whore
Spell Property SLSW_SuppressionSpell Auto Hidden 

;iNeeds
Spell Property _SNDrunkSpell Auto Hidden 
Spell Property _SNSKoomaSPell Auto Hidden 

;Defeat 
Faction Property DefeatFaction Auto Hidden 

;Vanilla Follower Alias - needed for EFF
ReferenceAlias Property Follower Auto 

;Extensible Follower Framework
Quest Property EFFQuest Auto Hidden 
ReferenceAlias[] Property EFFAliases Auto Hidden 

;Ultimate Follower Overhaul
Quest Property UFOQuest Auto Hidden 
ReferenceAlias[] Property UFOAliases Auto Hidden 

;Amazing Follower Tweaks
Quest Property AFTQuest Auto Hidden 
ReferenceAlias[] Property AFTAliases Auto Hidden 

;Deprecated

;0.71
Bool Property bMiniNeedsIsLoaded = False Auto Hidden 
string Property MiniNeeds = "MiniNeeds.esp" AutoReadOnly Hidden 
