Scriptname SLAdventures_MCM_StorageScript 
;Global Script to make various JsonUtil calls easier.

String Function GetFileVersion(String sFile) Global 
	return JsonUtil.GetStringValue(sFile, "Version")
EndFunction  

Function SaveFile(String sFile) Global 
	JsonUtil.Save(sFile)
EndFunction

Function StoreIntValue(String sFile, String sName, Int iValue) Global 
	JsonUtil.SetIntValue(sFile, sName, iValue)
EndFunction

Function StoreFloatValue(String sFile, String sName, Float fValue) Global 
	JsonUtil.SetFloatValue(sFile, sName, fValue)
EndFunction

Function StoreBoolValue(String sFile, String sName, Bool bValue) Global 
	If (bValue == True) 
		JsonUtil.SetIntValue(sFile, sName, 1)
	Else
		JsonUtil.SetIntValue(sFile, sName, 0)
	EndIf
EndFunction

Function StoreStringValue(String sFile, String sName, String sValue) Global 
	JsonUtil.SetStringValue(sFile, sName, sValue)
EndFunction

Int Function LoadIntValue(String sFile, String sName, Int iMin, Int iMax) Global
	Int FileValue = JsonUtil.GetIntValue(sFile, sName)
	If (FileValue < iMin)
		return iMin
	ElseIf (FileValue > iMax)
		return iMax
	Else
		return FileValue
	EndIf
EndFunction 

Float Function LoadFloatValue(String sFile, String sName, Float fMin, Float fMax, Float fInterval) Global 
	Float FileValue = JsonUtil.GetFloatValue(sFile, sName)
	If (FileValue < fMin)
		return fMin
	ElseIf (FileValue > fMax)
		return fMax
	Else
		return (Math.Floor(FileValue * (1/fInterval))) / (1/fInterval)
	EndIf
EndFunction

Bool Function LoadBoolValue(String sFile, String sName) Global 
	Int FileValue = JsonUtil.GetIntValue(sFile, sName)
	If (FileValue == 1)
		return True
	Else
		return False
	EndIf
EndFunction

String Function LoadStringValue(String sFile, String sName, String[] sValidValues) Global 
	String FileValue = JsonUtil.GetStringValue(sFile, sName)
	Int index = 0
	While (index < sValidValues.Length)
		If (FileValue == sValidValues[index]) 
			return FileValue
		EndIf
	index += 1	
	EndWhile
	return sValidValues[0]
EndFunction
