Scriptname SLAdventures_ProximityRapeScript extends Quest  

Event OnUpdate()
	TryRape()
EndEvent 

Event OnSleepStart(float afSleepStartTime, float afDesiredSleepEndTime)
	UnregisterForUpdate()
EndEvent

Event OnSleepStop(Bool abInterrupted)
	RegisterForSingleUpdate(Controller.fPollRate)
EndEvent

Function TryRape(Bool TreatAsNaked = False)

	UnregisterForUpdate()
	UnRegisterForSleep()
	If (bBlock == True)
		return
	Else
		bBlock = True
	EndIf

	If (Controller.IsIdle() != True)
		Unblock()
		return 
	EndIf
	
	If (MCM.bDebugRapeUpdateMessage == True)
		Debug.Notification("Proximity Rape Check.")
	EndIf
	
	If (bProximityRapeEnabled != True)
		If (MCM.bDebugRapeUpdateMessage == True)
			Debug.Notification("Proximity Rape is disabled, aborting.")
		EndIf
		Unblock()
		return 
	EndIf 
	
	String sFailedCondition = IsPossible(TreatAsNaked)
	If (sFailedCondition == "")
		If (MCM.bDebugRapeUpdateMessage == True)
			Debug.Notification("Conditions are met.")
		EndIf
		SLAdventures_RapistList.Revert()
		SLAdventures_RapeScanSpell.Cast(Player)
		Utility.Wait(3.0)
		;debug.notification("Number of attackers: " + SLAdventures_RapistList.GetSize() as string)
		;debug.notification((SLAdventures_RapistList.GetAt(0) as Actor).GetDisplayName())
		If (SLAdventures_RapistList.GetSize() >= iProximityRapeMinNumberAttackers)
			If (Controller.GangRape(SLAdventures_RapistList, SLAdventures_VictimList, AllowPursuit = True, AllowJoinIn = True) == True)
				AfterRape(Controller.GetLastRapists())
				SLAdventures_RapistList.Revert()
				SLAdventures_VictimList.Revert()
			EndIf
		Else 
			Debug.Notification("Not enough valid attackers found.")
		EndIf
	Else
		If (MCM.bDebugRapeUpdateMessage == True)
			Debug.Notification(sFailedCondition)
		EndIf
	EndIf
	
	Unblock()

EndFunction

Bool Function IsBlocked()
	return bBlock
EndFunction 

Function Unblock()
	bBlock = False
	RegisterForSleep()
	RegisterForSingleUpdate(Controller.fPollRate)
EndFunction

String Function IsPossible(Bool TreatAsNaked) 

	String ControllerError = Controller.IsPossible()
	If (ControllerError != "") 
		return ControllerError
	EndIf
	
	If (UI.IsMenuOpen("Dialogue Menu") == True)
		return "in dialogue"
	EndIf
	
	If (DLCModsComp.bDefeatIsLoaded == True) && (Player.IsInFaction(DLCModsComp.DefeatFaction))
		return "Running Defeat Scene"
	EndIf
	
	If (SLA_Utility.GetHoursPassed(fLastRape) < fRapeCoolDown)
		return "cooldown is not over"
	EndIf 
	
	If (bFollowersCanPreventRape == True)
		Actor[] Followers = DLCModsComp.GetFollowers()
		Int index = 0
		Cell PlayerCell = Player.GetParentCell()
		While (index < Followers.Length)
			If (Followers[index] != none) && ((PlayerCell == Followers[index].GetParentCell()) || (Player.GetDistance(Followers[index]) < 2048))
				return "prevented by Follower"
			EndIf
			index += 1
		EndWhile
	EndIf
	
	Bool bIsNaked
	
	If (TreatAsNaked == True)
		bIsNaked = True
	Else 
		bIsNaked = Crime.IsNaked(MCM.iNakedRule)
	EndIf
	
	Bool bIsNight = SLA_Utility.IsNight()
	Bool bIsInCity = SLA_Utility.IsInCity(Player)
	;/Bool bIsInDungeon = False
	
	If (Player.GetCurrentLocation() != none) && (Player.GetCurrentLocation().HasKeyWord(LocTypeDungeon) == True)
		bIsInDungeon = True
	EndIf/;
	
	Bool bIsUnarmed
	If (Player.GetEquippedSpell(1) != none) || (Player.GetEquippedSpell(0) != none)
		bIsUnarmed = False
	Else
		Int PlayerEquippedItem = Player.GetEquippedItemType(1)
		If ((PlayerEquippedItem == 0) || (PlayerEquippedItem == 9) || (PlayerEquippedItem == 11))
			PlayerEquippedItem = Player.GetEquippedItemType(0)
			If ((PlayerEquippedItem == 0) || (PlayerEquippedItem == 9) || (PlayerEquippedItem == 11))
				bIsUnarmed = True
			Else
				bIsUnarmed = False
			EndIf
		Else
			bIsUnarmed = False
		EndIf
	EndIf
	
	Bool bIsAroused
	If (Aroused.GetActorArousal(Player) >= MCM.iPlayerArousalThreshhold)
		bIsAroused = True
	Else
		bIsAroused = False
	EndIf
	
	Bool bIsWounded = (Player.GetActorValue("Health") < iTriggerHealthThreshold)
	Bool bIsExhausted = (Player.GetActorValue("Stamina") < iTriggerStaminaThreshold)
	
	Bool bIsThane = SLA_Utility.IsThane()
	
	;DD
	Bool bIsRestrained
	Bool bIsCollared
	If (DLCModsComp.bDDAssetsIsLoaded == True)
		If ((Player.WornHasKeyword(DLCModsComp.zad_DeviousArmbinder)) || (Player.WornHasKeyword(DLCModsComp.zad_DeviousYoke)) || (Player.WornHasKeyword(DLCModsComp.zad_DeviousBlindfold)) || ((Player.WornHasKeyword(DLCModsComp.zad_DeviousBoots)) && (bDDBootsMakeHelpless == True)))
			bIsRestrained = True
		Else
			bIsRestrained = False
		EndIf
		If (Player.WornHasKeyword(DLCModsComp.zad_DeviousCollar) == True)
			bIsCollared = True
		Else
			bIsCollared = False
		EndIf
	Else
		bIsRestrained = False
		iRapeWhenRestrained = 1
	EndIf
	
	;Drunk - RND, iNeeds, MiniNeeds
	Bool bIsDrunk = False
	If (DLCModsComp.IsPlayerDrunk(Player) == True)
		bIsDrunk = True
	EndIf
	
	;Drugged - Skooma Whore, iNeeds 
	Bool bIsDrugged = False
	If ((DLCModsComp.bSkoomaWhoreIsLoaded == True) && (Player.HasSpell(DLCModsComp.SLSW_SuppressionSpell) == True)) \
	|| ((DLCModsComp.biNeedsIsLoaded == True) && (Player.HasSpell(DLCModsComp._SNSkoomaSpell) == True))
		bIsDrugged = True
	EndIf
	
	; 0 = Not
	; 1 = Ignore
	; 2 = And
	; 3 = Or
	; 4 = Either
	; 5 = Either Not
	; 6 = Always
	; 7 = Or Not
	Int iMetConditions = 0
	Bool bAtLeastOneOr = False
	Bool bEitherIsMet = False
	Bool bAtLeastOneEither = False
	
	;NAKED
	If (iRapeWhenNaked == ALWAYS) 
		If (bIsNaked == True)
			return ""
		EndIf
	ElseIf (iRapeWhenNaked == NOT) 
		If (bIsNaked == True)
			return "must not be naked"
		EndIf
	ElseIf (iRapeWhenNaked == AND) 
		If (bIsNaked == False)
			return "must be naked"
		EndIf
	ElseIf (iRapeWhenNaked == OR) 
		bAtLeastOneOr = True
		If (bIsNaked == True)
			iMetConditions += 1
		EndIf
	ElseIf (iRapeWhenNaked == OR_NOT) 
		bAtLeastOneOr = True
		If (bIsNaked == False)
			iMetConditions += 1
		EndIf
	ElseIf (iRapeWhenNaked == OR_DOUBLE) 
		bAtLeastOneOr = True
		If (bIsNaked == True)
			iMetConditions += 2
		EndIf
	ElseIf (iRapeWhenNaked == OR_TRIPLE) 
		bAtLeastOneOr = True
		If (bIsNaked == True)
			iMetConditions += 3
		EndIf
	ElseIf (iRapeWhenNaked == EITHER) 
		bAtLeastOneEither = True
		If (bIsNaked == True)
			bEitherIsMet = True
		EndIf
	ElseIf (iRapeWhenNaked == EITHER_NOT)
		bAtLeastOneEither = True
		If (bIsNaked == False)
			bEitherIsMet = True
		EndIf
	EndIf
	
	;NIGHT
	If (iRapeWhenNight == ALWAYS) 
		If (bIsNight == True)
			return ""
		EndIf
	ElseIf (iRapeWhenNight == NOT) 
		If (bIsNight == True)
			return "must not be night"
		EndIf
	ElseIf (iRapeWhenNight == AND) 
		If (bIsNight == False)
			return "must be night"
		EndIf
	ElseIf (iRapeWhenNight == OR) 
		bAtLeastOneOr = True
		If (bIsNight == True)
			iMetConditions += 1
		EndIf
	ElseIf (iRapeWhenNight == OR_NOT) 
		bAtLeastOneOr = True
		If (bIsNight == False)
			iMetConditions += 1
		EndIf
	ElseIf (iRapeWhenNight == OR_DOUBLE) 
		bAtLeastOneOr = True
		If (bIsNight == True)
			iMetConditions += 2
		EndIf
	ElseIf (iRapeWhenNight == OR_TRIPLE) 
		bAtLeastOneOr = True
		If (bIsNight == True)
			iMetConditions += 3
		EndIf
	ElseIf (iRapeWhenNight == EITHER) 
		bAtLeastOneEither = True
		If (bIsNight == True)
			bEitherIsMet = True
		EndIf
	ElseIf (iRapeWhenNight == EITHER_NOT) 
		bAtLeastOneEither = True
		If (bIsNight == False)
			bEitherIsMet = True
		EndIf
	
	EndIf
	
	;CITY
	If (iRapeWhenInCity == ALWAYS) 
		If (bIsInCity == True)
			return ""
		EndIf
	ElseIf (iRapeWhenInCity == NOT) 
		If (bIsInCity == True)
			return "must not be in city"
		EndIf
	ElseIf (iRapeWhenInCity == AND) 
		If (bIsInCity == False)
			return "must be in city"
		EndIf
	ElseIf (iRapeWhenInCity == OR) 
		bAtLeastOneOr = True
		If (bIsInCity == True)
			iMetConditions += 1
		EndIf
	ElseIf (iRapeWhenInCity == OR_NOT) 
		bAtLeastOneOr = True
		If (bIsInCity == False)
			iMetConditions += 1
		EndIf
	ElseIf (iRapeWhenInCity == OR_DOUBLE) 
		bAtLeastOneOr = True
		If (bIsInCity == True)
			iMetConditions += 2
		EndIf
	ElseIf (iRapeWhenInCity == OR_TRIPLE) 
		bAtLeastOneOr = True
		If (bIsInCity == True)
			iMetConditions += 3
		EndIf
	ElseIf (iRapeWhenInCity == EITHER) 
		bAtLeastOneEither = True
		If (bIsInCity == True)
			bEitherIsMet = True
		EndIf
	ElseIf (iRapeWhenInCity == EITHER_NOT) 
		bAtLeastOneEither = True
		If (bIsInCity == False)
			bEitherIsMet = True
		EndIf
	EndIf
	
	;UNARMED
	If (iRapeWhenUnarmed == ALWAYS) 
		If (bIsUnarmed == True)
			return ""
		EndIf
	ElseIf (iRapeWhenUnarmed == NOT) 
		If (bIsUnarmed == True)
			return "must not be unarmed"
		EndIf
	ElseIf (iRapeWhenUnarmed == AND) 
		If (bIsUnarmed == False)
			return "must be unarmed"
		EndIf
	ElseIf (iRapeWhenUnarmed == OR) 
		bAtLeastOneOr = True
		If (bIsUnarmed == True)
			iMetConditions += 1
		EndIf
	ElseIf (iRapeWhenUnarmed == OR_NOT) 
		bAtLeastOneOr = True
		If (bIsUnarmed == False)
			iMetConditions += 1
		EndIf
	ElseIf (iRapeWhenUnarmed == OR_DOUBLE) 
		bAtLeastOneOr = True
		If (bIsUnarmed == True)
			iMetConditions += 2
		EndIf
	ElseIf (iRapeWhenUnarmed == OR_TRIPLE) 
		bAtLeastOneOr = True
		If (bIsUnarmed == True)
			iMetConditions += 3
		EndIf
	ElseIf (iRapeWhenUnarmed == EITHER) 
		bAtLeastOneEither = True
		If (bIsUnarmed == True)
			bEitherIsMet = True
		EndIf
	ElseIf (iRapeWhenUnarmed == EITHER_NOT) 
		bAtLeastOneEither = True
		If (bIsUnarmed == False)
			bEitherIsMet = True
		EndIf
	EndIf
	
	;AROUSED
	If (iRapeWhenAroused == ALWAYS) 
		If (bIsAroused == True)
			return ""
		EndIf
	ElseIf (iRapeWhenAroused == NOT) 
		If (bIsAroused == True)
			return "must not be aroused"
		EndIf
	ElseIf (iRapeWhenAroused == AND) 
		If (bIsAroused == False)
			return "must be aroused"
		EndIf
	ElseIf (iRapeWhenAroused == OR)
		bAtLeastOneOr = True
		If (bIsAroused == True)
			iMetConditions += 1
		EndIf
	ElseIf (iRapeWhenAroused == OR_NOT) 
		bAtLeastOneOr = True
		If (bIsAroused == False)
			iMetConditions += 1
		EndIf
	ElseIf (iRapeWhenAroused == OR_DOUBLE)
		bAtLeastOneOr = True
		If (bIsAroused == True)
			iMetConditions += 2
		EndIf
	ElseIf (iRapeWhenAroused == OR_TRIPLE)
		bAtLeastOneOr = True
		If (bIsAroused == True)
			iMetConditions += 3
		EndIf
	ElseIf (iRapeWhenAroused == EITHER) 
		bAtLeastOneEither = True
		If (bIsAroused == True)
			bEitherIsMet = True
		EndIf
	ElseIf (iRapeWhenAroused == EITHER_NOT) 
		bAtLeastOneEither = True
		If (bIsAroused == False)
			bEitherIsMet = True
		EndIf
	EndIf
	
	;Wounded
	If (iRapeWhenWounded == ALWAYS) 
		If (bIsWounded == True)
			return ""
		EndIf
	ElseIf (iRapeWhenWounded == NOT) 
		If (bIsWounded == True)
			return "must not be wounded"
		EndIf
	ElseIf (iRapeWhenWounded == AND) 
		If (bIsWounded == False)
			return "must be wounded"
		EndIf
	ElseIf (iRapeWhenWounded == OR)
		bAtLeastOneOr = True
		If (bIsWounded == True)
			iMetConditions += 1
		EndIf
	ElseIf (iRapeWhenWounded == OR_NOT) 
		bAtLeastOneOr = True
		If (bIsWounded == False)
			iMetConditions += 1
		EndIf
	ElseIf (iRapeWhenWounded == OR_DOUBLE)
		bAtLeastOneOr = True
		If (bIsWounded == True)
			iMetConditions += 2
		EndIf
	ElseIf (iRapeWhenWounded == OR_TRIPLE)
		bAtLeastOneOr = True
		If (bIsWounded == True)
			iMetConditions += 3
		EndIf
	ElseIf (iRapeWhenWounded == EITHER) 
		bAtLeastOneEither = True
		If (bIsWounded == True)
			bEitherIsMet = True
		EndIf
	ElseIf (iRapeWhenWounded == EITHER_NOT) 
		bAtLeastOneEither = True
		If (bIsWounded == False)
			bEitherIsMet = True
		EndIf
	EndIf
	
	;Exhausted
	If (iRapeWhenExhausted == ALWAYS) 
		If (bIsExhausted == True)
			return ""
		EndIf
	ElseIf (iRapeWhenExhausted == NOT) 
		If (bIsExhausted == True)
			return "must not be exhausted"
		EndIf
	ElseIf (iRapeWhenExhausted == AND) 
		If (bIsExhausted == False)
			return "must be exhausted"
		EndIf
	ElseIf (iRapeWhenExhausted == OR)
		bAtLeastOneOr = True
		If (bIsExhausted == True)
			iMetConditions += 1
		EndIf
	ElseIf (iRapeWhenExhausted == OR_NOT) 
		bAtLeastOneOr = True
		If (bIsExhausted == False)
			iMetConditions += 1
		EndIf
	ElseIf (iRapeWhenExhausted == OR_DOUBLE)
		bAtLeastOneOr = True
		If (bIsExhausted == True)
			iMetConditions += 2
		EndIf
	ElseIf (iRapeWhenExhausted == OR_TRIPLE)
		bAtLeastOneOr = True
		If (bIsExhausted == True)
			iMetConditions += 3
		EndIf
	ElseIf (iRapeWhenExhausted == EITHER) 
		bAtLeastOneEither = True
		If (bIsExhausted == True)
			bEitherIsMet = True
		EndIf
	ElseIf (iRapeWhenExhausted == EITHER_NOT) 
		bAtLeastOneEither = True
		If (bIsExhausted == False)
			bEitherIsMet = True
		EndIf
	EndIf
	
	;THANE
	If (iRapeWhenThane == ALWAYS) 
		If (bIsThane == True)
			return ""
		EndIf
	ElseIf (iRapeWhenThane == NOT) 
		If (bIsThane == True)
			return "must not be Thane"
		EndIf
	ElseIf (iRapeWhenThane == AND) 
		If (bIsThane == False)
			return "must be Thane"
		EndIf
	ElseIf (iRapeWhenThane == OR) 
		bAtLeastOneOr = True
		If (bIsThane == True)
			iMetConditions += 1
		EndIf
	ElseIf (iRapeWhenThane == OR_NOT) 
		bAtLeastOneOr = True
		If (bIsThane == False)
			iMetConditions += 1
		EndIf
	ElseIf (iRapeWhenThane == OR_DOUBLE) 
		bAtLeastOneOr = True
		If (bIsThane == True)
			iMetConditions += 2
		EndIf
	ElseIf (iRapeWhenThane == OR_TRIPLE) 
		bAtLeastOneOr = True
		If (bIsThane == True)
			iMetConditions += 3
		EndIf
	ElseIf (iRapeWhenThane == EITHER) 
		bAtLeastOneEither = True
		If (bIsThane == True)
			bEitherIsMet = True
		EndIf
	ElseIf (iRapeWhenThane == EITHER_NOT) 
		bAtLeastOneEither = True
		If (bIsThane == False)
			bEitherIsMet = True
		EndIf
	EndIf
	
	;RESTRAINED - Mod added, check only if DD is installed
	If (DLCModsComp.bDDAssetsIsLoaded == True)
		If (iRapeWhenRestrained == ALWAYS) 
			If (bIsRestrained == True)
				return ""
			EndIf
		ElseIf (iRapeWhenRestrained == NOT) 
			If (bIsRestrained == True)
				return "must not be restrained"
			EndIf
		ElseIf (iRapeWhenRestrained == AND) 
			If (bIsRestrained == False)
				return "must be restrained"
			EndIf
		ElseIf (iRapeWhenRestrained == OR)
			bAtLeastOneOr = True
			If (bIsRestrained == True)
				iMetConditions += 1
			EndIf
		ElseIf (iRapeWhenRestrained == OR_NOT) 
			bAtLeastOneOr = True
			If (bIsRestrained == False)
				iMetConditions += 1
			EndIf
		ElseIf (iRapeWhenRestrained == OR_DOUBLE)
			bAtLeastOneOr = True
			If (bIsRestrained == True)
				iMetConditions += 2
			EndIf
		ElseIf (iRapeWhenRestrained == OR_TRIPLE)
			bAtLeastOneOr = True
			If (bIsRestrained == True)
				iMetConditions += 3
			EndIf
		ElseIf (iRapeWhenRestrained == EITHER) 
			bAtLeastOneEither = True
			If (bIsRestrained == True)
				bEitherIsMet = True
			EndIf
		ElseIf (iRapeWhenRestrained == EITHER_NOT) 
			bAtLeastOneEither = True
			If (bIsRestrained == False)
				bEitherIsMet = True
			EndIf
		EndIf
		
	;COLLARED - Mod added, check only if DD is installed	
		If (iRapeWhenCollared == ALWAYS) 
			If (bIsCollared == True)
				return ""
			EndIf
		ElseIf (iRapeWhenCollared == NOT) 
			If (bIsCollared == True)
				return "must not be collared"
			EndIf
		ElseIf (iRapeWhenCollared == AND) 
			If (bIsCollared == False)
				return "must be collared"
			EndIf
		ElseIf (iRapeWhenCollared == OR)
			bAtLeastOneOr = True
			If (bIsCollared == True)
				iMetConditions += 1
			EndIf
		ElseIf (iRapeWhenCollared == OR_NOT) 
			bAtLeastOneOr = True
			If (bIsCollared == False)
				iMetConditions += 1
			EndIf
		ElseIf (iRapeWhenCollared == OR_DOUBLE)
			bAtLeastOneOr = True
			If (bIsCollared == True)
				iMetConditions += 1
			EndIf
		ElseIf (iRapeWhenCollared == OR_TRIPLE)
			bAtLeastOneOr = True
			If (bIsCollared == True)
				iMetConditions += 1
			EndIf
		ElseIf (iRapeWhenCollared == EITHER) 
			bAtLeastOneEither = True
			If (bIsCollared == True)
				bEitherIsMet = True
			EndIf
		ElseIf (iRapeWhenCollared == EITHER_NOT) 
			bAtLeastOneEither = True
			If (bIsCollared == False)
				bEitherIsMet = True
			EndIf
		EndIf
	EndIf
	
	;DRUNK - Mod added, check only if RND or another Survival Mod is installed
	If (DLCModsComp.bRNDIsLoaded == True) || (DLCModsComp.biNeedsIsLoaded == True) 
		If (iRapeWhenDrunk == ALWAYS) 
			If (bIsDrunk == True)
				return ""
			EndIf
		ElseIf (iRapeWhenDrunk == NOT) 
			If (bIsDrunk == True)
				return "must not be drunk"
			EndIf
		ElseIf (iRapeWhenDrunk == AND) 
			If (bIsDrunk == False)
				return "must be drunk"
			EndIf
		ElseIf (iRapeWhenDrunk == OR) 
			bAtLeastOneOr = True
			If (bIsDrunk == True)
				iMetConditions += 1
			EndIf
		ElseIf (iRapeWhenDrunk == OR_NOT) 
			bAtLeastOneOr = True
			If (bIsDrunk == False)
				iMetConditions += 1
			EndIf
		ElseIf (iRapeWhenDrunk == OR_DOUBLE) 
			bAtLeastOneOr = True
			If (bIsDrunk == True)
				iMetConditions += 2
			EndIf
		ElseIf (iRapeWhenDrunk == OR_TRIPLE) 
			bAtLeastOneOr = True
			If (bIsDrunk == True)
				iMetConditions += 3
			EndIf
		ElseIf (iRapeWhenDrunk == EITHER)
			bAtLeastOneEither = True
			If (bIsDrunk == True)
				bEitherIsMet = True
			EndIf
		ElseIf (iRapeWhenDrunk == EITHER_NOT) 
			bAtLeastOneEither = True
			If (bIsDrunk == False)
				bEitherIsMet = True
			EndIf
		EndIf
	EndIf
	
	;DRUGGED - Mod added, check only if Skoome Whore or iNeeds is installed
	If (DLCModsComp.bSkoomaWhoreIsLoaded == True) || (DLCModsComp.biNeedsIsLoaded == True)
		If (iRapeWhenDrugged == ALWAYS) 
			If (bIsDrugged == True)
				return ""
			EndIf
		ElseIf (iRapeWhenDrugged == NOT) 
			If (bIsDrugged == True)
				return "must not be drugged"
			EndIf
		ElseIf (iRapeWhenDrugged == AND) 
			If (bIsDrugged == False)
				return "must be drugged"
			EndIf
		ElseIf (iRapeWhenDrugged == OR) 
			bAtLeastOneOr = True
			If (bIsDrugged == True)
				iMetConditions += 1
			EndIf
		ElseIf (iRapeWhenDrugged == OR_NOT) 
			bAtLeastOneOr = True
			If (bIsDrugged == False)
				iMetConditions += 1
			EndIf
		ElseIf (iRapeWhenDrugged == OR_DOUBLE) 
			bAtLeastOneOr = True
			If (bIsDrugged == True)
				iMetConditions += 2
			EndIf
		ElseIf (iRapeWhenDrugged == OR_TRIPLE) 
			bAtLeastOneOr = True
			If (bIsDrugged == True)
				iMetConditions += 3
			EndIf
		ElseIf (iRapeWhenDrugged == EITHER)
			bAtLeastOneEither = True
			If (bIsDrugged == True)
				bEitherIsMet = True
			EndIf
		ElseIf (iRapeWhenDrugged == EITHER_NOT) 
			bAtLeastOneEither = True
			If (bIsDrugged == False)
				bEitherIsMet = True
			EndIf
		EndIf
	EndIf
	
	;AND and NOT are sorted out, as well as ALWAYS
	;forget IGNORE anyway
	;now, sort out EITHER and EITHER NOT
	
	If (bAtLeastOneEither == True) && (bEitherIsMet == False) 
		return "no EITHER condition is met"
	EndIf
	
	;done, now OR
	
	If (bAtLeastOneOr == True) && (iMetConditions < iNumRapeConditions)
		return "not enough OR conditions are met"
	EndIf
	
	;If we have made it this far, all conditions are met
	return ""

EndFunction

Bool Function IsValidAttacker(Actor akActor) 

	If (Controller.IsValidAttacker(akActor) == False)
		return False
	EndIf
	
	If (Player.IsSneaking() == True) && (Player.IsDetectedBy(akActor) == False)
		return False
	EndIf 
	
	If (Aroused.GetActorArousal(akActor) < iRapeAttackerArousalThreshhold)
		return False
	EndIf
	
	If (akActor.HasKeyword(ActorTypeNPC) == True)
	
		If ((sRapeAttackersGender == "Male") && (SexLab.GetGender(akActor) != 0))
			return False
		EndIf
	
		If ((sRapeAttackersGender == "Female") && (SexLab.GetGender(akActor) != 1))
			return False
		EndIf
		
		If ((bMoralityMatters == True) && (akActor.GetActorValue("Morality") == 3)) && ((bCorruptGuards == False) || (akActor.IsGuard() == False))
			return False
		EndIf
		
		If (bFriendsRape == False) && (akActor.GetRelationshipRank(Player) >= 1) && (akActor.GetRelationshipRank(Player) < 4) 
			return False
		EndIf
		
		If (bLoversRape == False) && (akActor.GetRelationshipRank(Player) == 4) 
			return False
		EndIf
	
		If (akActor.HasKeyword(IsBeastRace) == True) 
			If (iBeastRaceChance == 0)
				return False
			ElseIf (Utility.RandomInt(1,100) > iBeastRaceChance)
				return False
			EndIf
		EndIf
	
		If (akActor.IsGuard() == True) 
			If (iGuardChance == 0) 
				return False
			ElseIf (akActor.GetCrimeFaction().GetCrimeGold() < iMinBountyForGuardRape) 
				return False
			ElseIf (Utility.RandomInt(1,100) > iGuardChance)
				return False
			EndIf
		Else
			If (iNonGuardChance == 0)
				return False
			ElseIf (Utility.RandomInt(1,100) > iNonGuardChance)
				return False
			EndIf
		EndIf
	
		If (akActor.GetRace() == ElderRace) 
			If (iElderChance == 0) 
				return False
			ElseIf (Utility.RandomInt(1,100) > iElderChance)
				return False
			EndIf
		EndIf
		
		If (akActor.IsInFaction(CurrentFollowerFaction) == True) 
			If (iFollowerChance == 0)
				return False
			ElseIf (Utility.RandomInt(1,100) > iFollowerChance)
				return False
			EndIf
		EndIf
	
		return True
		
	ElseIf (akActor.HasKeyword(ActorTypeAnimal) == True)
		
		If (akActor.GetActorBase().GetRace() == ChickenRace) || (akActor.GetActorBase().GetRace() == HareRace)
			return False
		EndIf
		
		If (iAnimalCreatureChance == 0)
			return False
		ElseIf (Utility.RandomInt(1,100) > iAnimalCreatureChance)
			return False
		EndIf
		
		return True
		
		return ((iAnimalCreatureChance == 0) || (Utility.RandomInt(1,100) > iAnimalCreatureChance))
		
	ElseIf (akActor.HasKeyword(ActorTypeCreature) == True)
	
		If (iOtherCreatureChance == 0)
			return False
		ElseIf (Utility.RandomInt(1,100) > iOtherCreatureChance)
			return False
		EndIf
		
		return True
		
	EndIf

EndFunction

Function HotKeyToggleRape()

	bProximityRapeEnabled = !bProximityRapeEnabled
	If (bProximityRapeEnabled == True)
		RegisterForSingleUpdate(Controller.fPollrate)
		RegisterForSleep()
		Debug.Notification("Sexlab Adventures: Proximity Rape toggled on.")
	ElseIf (bProximityRapeEnabled == False) 
		UnregisterForUpdate()
		UnRegisterForSleep()
		Debug.Notification("Sexlab Adventures: Proximity Rape toggled off.")
	EndIf

EndFunction

Function AfterRape(Actor[] Rapists)

	If (SLA_Utility.HasNPCs(Rapists) == True)
		Int index = 0
		Actor akGuard = none
	
		While (index < Rapists.Length) && (Rapists[index] != none) && (akGuard == none)
			If (Rapists[index].IsGuard() == True)
				akGuard = Rapists[index]
			EndIf
			index += 1
		EndWhile
		
		Int[] Scenarios = new Int[5]
	
		If (akGuard != none)
			Scenarios[0] = iAfterRapeImprisonmentChance
		Else
			Scenarios[0] = 0
		EndIf
		If (DLCModsComp.bSimpleSlaveryIsLoaded == True)
			Scenarios[1] = iAfterRapeSimpleSlaveryChance
		Else
			Scenarios[1] = 0
		EndIf
		Scenarios[2] = iAfterRapeRobberyChance 
		Scenarios[3] = iAfterRapeSlutCoinChance
		Scenarios[4] = iAfterRapeLeftAloneChance
		
		Int Result = Utility.RandomInt(0, Scenarios[0] + Scenarios[1] + Scenarios[2] + Scenarios[3] + Scenarios[4] - 1)
		
		If (Result < Scenarios[0])
			PayBountyOrJailPlayer(akGuard)
		ElseIf (Result < Scenarios[0] + Scenarios[1])
			SimpleSlaveryEntry()
		ElseIf (Result < Scenarios[0] + Scenarios[1] + Scenarios[2])
			RobPlayer(Rapists.Length > 1)
		ElseIf (Result < Scenarios[0] + Scenarios[1] + Scenarios[2] + Scenarios[3])
			SlutCoin(Rapists.Length * 3)
		EndIf
	EndIf

EndFunction

Function RobPlayer(Bool MultipleAttackers)
	
	If (MultipleAttackers == True) 
		Debug.Notification("Your attackers help themselves with your inventory...")
	Else
		Debug.Notification("Your attacker helps themselves with your inventory...")
	EndIf
	
	If (bRobAllItems == True)
		Player.RemoveAllItems(abRemoveQuestItems = bRobberyRobQuestItems)
	Else
		If (bRobAllGold == True) 
			Player.RemoveItem(Gold001, Player.GetItemCount(Gold001), True)
		EndIf
		If (bRobRandomItems == True)
			Int ItemsStolen = 0
			Bool Break = False
			Int Attempts = 0
			Bool ItemFound = False
			Form akItem = none
	
			While (ItemsStolen < iItemsToRob) && (Break == False)
				ItemFound = False
				While (Attempts < 5) && (ItemFound == False)
					akItem = SLA_Utility.GetRandomItemFromContainer(Player as ObjectReference)
					If (akItem != none)
						If (Player.IsEquipped(akItem) == False) && (SLA_Utility.IsQuestItem(akItem) == False)
							If (akItem == Gold001) 
								Player.RemoveItem(akItem, Utility.RandomInt(10, 50), True)
							Else
								Player.RemoveItem(akItem, 1, True)
							EndIf
							ItemsStolen += 1
							ItemFound = True
						Else
							Attempts += 1
							If (Attempts >= 5)
								;After 5 consecutive failed attempts we are going to assume the player has no valid items left in their inventory.
								Break = True	
							EndIf
						EndIf
					Else
						;Player has no items left in their inventory
						Attempts = 5
						Break = True
					EndIf
				EndWhile
				Attempts = 0
			EndWhile
		EndIf
	EndIf
	
EndFunction  

Function PayBountyOrJailPlayer(Actor akGuard)
	
	Int iPlayerGold = Player.GetItemCount(Gold001)
	Faction akFaction = SLA_Utility.GetCurrentCrimeFaction(Player as ObjectReference)
	
	If (SLA_Utility.PayCrimeGold(akFaction, iPlayerGold) > 0)
		Debug.Notification("Unable to pay your bounty, you are arrested by the guard...")
		If (DLCModsComp.bPOPIsLoaded == True)
			Int iFaction = SLA_Utility.GetCurrentCrimeFactionAsInt(Player as ObjectReference)
			akGuard.SendModEvent("xpoArrestPC", "", 0)
		Else
			akFaction.SendPlayerToJail()
		EndIf
	Else
		Debug.Notification("The guard forces you to pay your bounty.")
	EndIf
	
EndFunction 

Function SlutCoin(Int Pieces) 
	
	Debug.Notification("Your attackers throw some money on the ground for you to collect.")
	While (Pieces > 0)
		Player.Additem(SLA_Utility.Gold001, 1, True)
		Player.DropObject(SLA_Utility.Gold001, 1)
		Pieces -= 1
	EndWhile 
	
EndFunction

Function SimpleSlaveryEntry()
	
	Debug.Notification("Unable to defend yourself, your attackers kidnap you and sell you into slavery...")
	Utility.Wait(2.0)
	SendModEvent("SSLV Entry")
	
EndFunction 

SLAdventures_ProximityRapeScript Function GetInstance() Global
	return Game.GetFormFromFile(0x238E6, "SLAdventures.esp") as SLAdventures_ProximityRapeScript
EndFunction

Function SaveMCMOptions(String FileName) 

	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "ProximityRapeEnabled", bProximityRapeEnabled)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeWhenNaked", iRapeWhenNaked)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeWhenNight", iRapeWhenNight)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeWhenInCity", iRapeWhenInCity)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeWhenUnarmed", iRapeWhenUnarmed)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeWhenAroused", iRapeWhenAroused)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeWhenThane", iRapeWhenThane)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeWhenRestrained", iRapeWhenRestrained)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeWhenDrunk", iRapeWhenDrunk)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeWhenDrugged", iRapeWhenDrugged)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeWhenCollared", iRapeWhenCollared)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeWhenWounded", iRapeWhenWounded)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeWhenExhausted", iRapeWhenExhausted)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "ProximityRapeMinNumberAttackers", iProximityRapeMinNumberAttackers)
	
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeTriggerHealthThreshold", iTriggerHealthThreshold)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeTriggerStaminaThreshold", iTriggerStaminaThreshold)
	
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeNumberOfConditions", iNumRapeConditions)
	SLAdventures_MCM_StorageScript.StoreStringValue(FileName, "RapeAttackerGender", sRapeAttackersGender)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeAttackerArousalThreshold", iRapeAttackerArousalThreshhold)
	
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, "RapeCooldown", fRapeCoolDown)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeDDBootsMakeHelpless", bDDBootsMakeHelpless)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeMinBountyForGuardRape", iMinBountyForGuardRape)
	
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeMoralityMatters", bMoralityMatters)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeFriendsRape", bFriendsRape)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeLoversRape", bLoversRape)
	
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeBeastRaceChance", iBeastRaceChance)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeElderChance", iElderChance)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeGuardChance", iGuardChance)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeNonGuardChance", iNonGuardChance)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeOtherCreatureChance", iOtherCreatureChance)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeAnimalCreatureChance", iAnimalCreatureChance)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeFollowerChance", iFollowerChance)
	
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeScenarioRobberyChance", iAfterRapeRobberyChance)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeScenarioSimpleSlaveryChance", iAfterRapeSimpleSlaveryChance)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeScenarioJailedChance", iAfterRapeImprisonmentChance)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeScenarioSlutCoin", iAfterRapeSlutCoinChance)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeScenarioNone", iAfterRapeLeftAloneChance)
	
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "ProximityRapeAfterRobAllItems", bRobAllItems)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "ProximityRapeAfterRobAllGold", bRobAllGold)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "ProximityRapeAfterRobRandomItems", bRobRandomItems)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "ProximityRapeAfterRobQuestItems", bRobberyRobQuestItems)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "ProximityRapeAfterRobItemsToRob", iItemsToRob)

EndFunction 

Function LoadMCMOptions(String FileName) 

	bProximityRapeEnabled = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "ProximityRapeEnabled")
	If (bProximityRapeEnabled == True) 
		RegisterForSingleUpdate(Controller.fPollrate)
		RegisterForSleep()
	Else 
		UnregisterForUpdate()
		UnRegisterForSleep()
	EndIf
	iRapeWhenNaked = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeWhenNaked", 0, 7)
	iRapeWhenNight = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeWhenNight", 0, 7)
	iRapeWhenInCity = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeWhenInCity", 0, 7)
	iRapeWhenUnarmed = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeWhenUnarmed", 0, 7)
	iRapeWhenAroused = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeWhenAroused", 0, 7)
	iRapeWhenThane = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeWhenThane", 0, 7)
	iRapeWhenRestrained = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeWhenRestrained", 0, 7)
	iRapeWhenDrunk = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeWhenDrunk", 0, 7)
	iRapeWhenDrugged = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeWhenDrugged", 0, 7)
	iRapeWhenCollared = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeWhenCollared", 0, 7)
	iRapeWhenWounded = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeWhenWounded", 0, 7)
	iRapeWhenExhausted = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeWhenExhausted", 0, 7)
	
	iTriggerHealthThreshold = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeTriggerHealthThreshold", 1, 200)
	iTriggerStaminaThreshold = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeTriggerStaminaThreshold", 1, 200)
	
	iNumRapeConditions = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeNumberOfConditions", 1, 20)
	String[] StripTypes = new String[4]
	StripTypes[0] = "Strip"
	StripTypes[1] = "Drop"
	StripTypes[2] = "Steal"
	StripTypes[3] = "Destroy"
	String[] AttackerGenders = new String[3]
	AttackerGenders[0] = "Male"
	AttackerGenders[1] = "Female"
	AttackerGenders[2] = "Either"
	sRapeAttackersGender = SLAdventures_MCM_StorageScript.LoadStringValue(FileName, "RapeAttackerGender", AttackerGenders)
	iRapeAttackerArousalThreshhold = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeAttackerArousalThreshold", 0, 100)
	
	fRapeCoolDown = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, "RapeCooldown", 0.25, 6.0, 0.25)

	bDDBootsMakeHelpless = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeDDBootsMakeHelpless")
	iMinBountyForGuardRape = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeMinBountyForGuardRape", 0, 999)
	
	bMoralityMatters = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeMoralityMatters")
	bFriendsRape = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeFriendsRape")
	bLoversRape = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeLoversRape")
	
	iBeastRaceChance = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeBeastRaceChance", 0, 100)
	iElderChance = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeElderChance", 0, 100)
	iGuardChance = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeGuardChance", 0, 100)
	iNonGuardChance = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeNonGuardChance", 0, 100)
	iOtherCreatureChance = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeOtherCreatureChance", 0, 100)
	iAnimalCreatureChance = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeAnimalCreatureChance", 0, 100)
	iFollowerChance = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeFollowerChance", 0, 100)
	
	iAfterRapeRobberyChance = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeScenarioRobberyChance", 0, 100)
	iAfterRapeSimpleSlaveryChance = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeScenarioSimpleSlaveryChance", 0, 100)
	iAfterRapeImprisonmentChance = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeScenarioJailedChance", 0, 100)
	iAfterRapeSlutCoinChance = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeScenarioSlutCoin", 0, 100)
	iAfterRapeLeftAloneChance = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeScenarioNone", 0, 100)

	bRobAllItems = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "ProximityRapeAfterRobAllItems")
	bRobAllGold = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "ProximityRapeAfterRobAllGold")
	bRobRandomItems = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "ProximityRapeAfterRobRandomItems")
	bRobberyRobQuestItems = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "ProximityRapeAfterRobQuestItems")
	iItemsToRob = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "ProximityRapeAfterRobItemsToRob", 1, 20)
	
EndFunction 

Bool bBlock = False
Actor Property Player Auto 
SLAdventures_MCM_Script Property MCM Auto 
SLAdventures_GangRapeController Property Controller Auto 
SLAdventures_Utility Property SLA_Utility Auto 
SLAdventures_CrimeScript Property Crime Auto 
slaframeworkscr Property Aroused Auto 
SLAdventures_DLCAndModCompScript Property DLCModsComp Auto 
SexLabFramework Property Sexlab Auto 
FormList Property SLAdventures_RapistList Auto 
FormList Property SLAdventures_VictimList Auto 
Spell Property SLAdventures_RapeScanSpell Auto 
Keyword Property ActorTypeCreature Auto 
Keyword Property ActorTypeAnimal Auto 
Keyword Property ActorTypeNPC Auto 
Keyword Property IsBeastRace Auto 
Race Property ElderRace Auto 
Race Property ChickenRace Auto 
Race Property HareRace Auto 
MiscObject Property Gold001 Auto 
Faction Property CurrentFollowerFaction Auto 

Bool Property bProximityRapeEnabled = True Auto Hidden 
Bool Property bProximityRapeWhenUndressing = True Auto Hidden 
Float Property fLastRape Auto Hidden 
Int Property iRapeWhenNaked = 2 Auto Hidden			; 0 = not
Int Property iRapeWhenNight = 3 Auto Hidden			; 1 = ignore
Int Property iRapeWhenInCity = 0 Auto Hidden		; 2 = and
Int Property iRapeWhenUnarmed = 3 Auto Hidden		; 3 = or 
Int Property iRapeWhenAroused = 3 Auto Hidden 		; 4 = either
Int Property iRapeWhenThane = 1 Auto Hidden			; 5 = either not
Int Property iRapeWhenRestrained = 1 Auto Hidden	; 6 = always
Int Property iRapeWhenDrunk = 1 Auto Hidden			; 7 = or not
Int Property iRapeWhenDrugged = 1 Auto Hidden
Int Property iRapeWhenCollared = 1 Auto Hidden 
Int Property iRapeWhenWounded = 1 Auto Hidden 
Int Property iRapeWhenExhausted = 1 Auto Hidden 
Int Property iProximityRapeMinNumberAttackers = 1 Auto Hidden 

Int Property iTriggerHealthThreshold = 50 Auto Hidden 
Int Property iTriggerStaminaThreshold = 50 Auto Hidden 
Int Property iNumRapeConditions = 3 Auto Hidden
Int Property iNumRapeConditionsMax = 0 Auto Hidden
String Property sRapeAttackersGender = "Male" Auto Hidden			;male, female, either.
Int Property iRapeAttackerArousalThreshhold = 25 Auto Hidden
Float Property fRapeCoolDown = 1.0 Auto Hidden 
Bool Property bDDBootsMakeHelpless = False Auto Hidden 
Int Property iMinBountyForGuardRape = 100 Auto Hidden 
Bool Property bCorruptGuards = False Auto Hidden 

Bool Property bMoralityMatters = False Auto Hidden 
Bool Property bFriendsRape = True Auto Hidden 
Bool Property bLoversRape = True Auto Hidden 

Int Property iBeastRaceChance = 0 Auto Hidden 
Int Property iElderChance = 0 Auto Hidden 
Int Property iGuardChance = 100 Auto Hidden 
Int Property iNonGuardChance = 100 Auto Hidden 
Int Property iOtherCreatureChance = 100 Auto Hidden 
Int Property iAnimalCreatureChance = 100 Auto Hidden  
Int Property iFollowerChance = 0 Auto Hidden 

Bool Property bRobAllItems = False Auto Hidden 			
Bool Property bRobAllGold = False Auto Hidden 			
Bool Property bRobRandomItems = True Auto Hidden 		
Bool Property bRobberyRobQuestItems = False Auto Hidden 
Int Property iItemsToRob = 5 Auto Hidden 				

Int Property iAfterRapeRobberyChance = 0 Auto Hidden 
Int Property iAfterRapeSimpleSlaveryChance = 0 Auto Hidden 
Int Property iAfterRapeImprisonmentChance = 0 Auto Hidden
Int Property iAfterRapeSlutCoinChance = 0 Auto Hidden 
Int Property iAfterRapeLeftAloneChance = 100 Auto Hidden 

Bool Property bFollowersCanPreventRape = False Auto Hidden 

;Read-only properties
Int Property AND = 0 AutoReadOnly 
Int Property NOT = 1 AutoReadOnly 
Int Property OR = 2 AutoReadOnly 
Int Property OR_NOT = 3 AutoReadOnly 
Int Property OR_DOUBLE = 4 AutoReadOnly 
Int Property OR_TRIPLE = 5 AutoReadOnly 
Int Property EITHER = 6 AutoReadOnly 
Int Property EITHER_NOT = 7 AutoReadOnly 
Int Property ALWAYS = 8 AutoReadOnly 
Int Property IGNORE = 9 AutoReadOnly 
