Scriptname SLAdventures_SleepRapeScript extends Quest  

Event OnSleepStart(float afSleepStartTime, float afDesiredSleepEndTime)

	UnRegisterForUpdate()
	If (bRapeAlwaysSleepNaked == True)
		PlayerSexTracker.StripActor("Strip", Thieves = new Actor[1], UseSexlabStrip = False)
	EndIf
	
	Location akLocation = Player.GetCurrentLocation()
	
	;Sleep Creep
	If (SLA_Utility.IsInCityOrHabitation(Player) == True) && ((MCM.iSleepCreepChanceCum > 0) || (MCM.iSleepCreepChanceTheft > 0))
		SleepCreep.SleepCreepStart(Player)
	EndIf
	
	;Chance for Sleep Rape
	Int iLocationType	;1 = City, habitation or dwelling, 2 = dungeon, 3 = wilderness
	Int iChance
	If (SLA_Utility.IsInCityOrHabitation(Player))
		iLocationType = 1
		iChance = iRapeChanceSleepCity
	ElseIf (akLocation.HasKeyWord(LocTypeDungeon))
		iLocationType = 2
		iChance = iRapeChanceSleepDungeon
	Else
		iLocationType = 3
		iChance = iRapeChanceSleepWilderness
	EndIf
	
	;Chance Modifier
	Float fChanceMod = 1.0
	If (fRapeSleepModNaked > 1.0) && (Crime.IsNaked(MCM.iNakedRule) == True)
		fChanceMod = fChanceMod * fRapeSleepModNaked
	EndIf
	If (fRapeSleepModAroused > 1.0) && (Aroused.GetActorArousal(Player) >= MCM.iPlayerArousalThreshhold)
		fChanceMod = fChanceMod * fRapeSleepModAroused
	EndIf
	If (DLCModsComp.IsDrunkModLoaded() == True) && (DLCModsComp.IsPlayerDrunk(Player) == True)
		fChanceMod = fChanceMod * fRapeSleepModDrunk
	EndIf
	
	If (bFollowersCanPreventRape == True)
		Actor[] Followers = DLCModsComp.GetFollowers()
		Int index = 0
		Cell PlayerCell = Player.GetParentCell()
		While (index < Followers.Length)
			If (Followers[index] != none) && ((PlayerCell == Followers[index].GetParentCell()) || (Player.GetDistance(Followers[index]) < 2048))
				return 
			EndIf
			index += 1
		EndWhile
	EndIf
	
	Int DesiredSleepHours = ((afDesiredSleepEndTime - afSleepStartTime) * 24) as Int
	Bool TriggerAttack = False
	Int iAttackAfterHours = Utility.RandomInt(1, DesiredSleepHours)
	Int iModifiedChance = (iChance * fChanceMod) as Int
	If (Utility.RandomInt(1, 100) <= iModifiedChance) 
		TriggerAttack = True
	EndIf
	
	If (TriggerAttack == True)		
		Game.DisablePlayerControls(abLooking = True, abCamSwitch = True, abMenu = True)
		Game.ForceFirstPerson()
		ObjectReference Marker = Player.PlaceAtMe(XMarker)
		Player.MoveTo(Marker, afZOffset = 1.0)
		Marker.Disable()
		Debug.Notification("Strong hands are pulling you out of bed...")
		Player.PlayIdle(WakeUpIdle)
		Utility.Wait(1)
		Game.ForceThirdPerson()
		Game.EnablePlayerControls()
		FormList Attackers = FillAttackerFormList(iLocationType)
		If (Attackers != none) && (Attackers.GetSize() != 0)
			Bool Success = RapeController.GangRape(Attackers, AllowPursuit = False)
			If (Success == True) 
				AfterRape(RapeController.GetLastRapists(), iLocationType == 1)
			EndIf
			SpawnedActors = 0
			ClearAttackerFormList(Attackers)
		EndIf
	EndIf
	
EndEvent 

Event OnSleepStop(Bool abInterrupted)
	If (abInterrupted == False)
		SleepCreep.SleepCreepShowMessages()
	EndIf
EndEvent 

FormList Function FillAttackerFormList(Int LocationType)
	;Select Actors from the current Cell or Spawn some
	;Return either the FormList for spawned actors 
	;or the one for selected ones
	
	Cell akCell = Player.GetParentCell() 
	Int index
	
	If (LocationType == 1) ;City, but not player home
		
		Int iFormType = Player.GetType()
		index = akCell.GetNumRefs(iFormType)
		Actor akActor = none
		
		SLAdventures_SelectedAttackersList.Revert()
		While (index > 0) && (akActor == none)
			index -= 1
			akActor = akCell.GetNthRef(index, iFormType) as Actor
			;debug.notification("Testing Actor " + akActor.GetActorBase().GetName() + " for Sleep Rape.")
			If (IsValidAttacker(akActor) == True)
				;debug.notification("Actor " + akActor.GetActorBase().GetName() + " added to selected actor list.")
				SLAdventures_SelectedAttackersList.AddForm(akActor)
			Else 
				akActor = none 
			EndIf
		EndWhile
		
		return SLAdventures_SelectedAttackersList
		
	ElseIf (LocationType == 2) ;Dungeon
		
		Int iFormType = Player.GetType()
		index = akCell.GetNumRefs(iFormType)
		Actor akActor
		
		SLAdventures_SelectedAttackersList.Revert()
		While (index > 0) && (akActor == none)
			index -= 1
			akActor = akCell.GetNthRef(index, iFormType) as Actor
			If (IsValidAttacker(akActor) == True)
				SLAdventures_SelectedAttackersList.AddForm(akActor)
			Else 
				akActor = none 
			EndIf
		EndWhile
		
		If (SLAdventures_SelectedAttackersList.GetSize() == 0)
			return SpawnActorsForRape(Player.GetCurrentLocation())
		Else 
			return SLAdventures_SelectedAttackersList
		EndIf
		
	ElseIf (LocationType == 3) ;Wilderness
		
		Int iFormType = Player.GetType()
		index = akCell.GetNumRefs(iFormType)
		Actor akActor
		
		SLAdventures_SelectedAttackersList.Revert()
		While (index > 0) && (akActor == none)
			index -= 1
			akActor = akCell.GetNthRef(index, iFormType) as Actor
			If (IsValidAttacker(akActor) == True)
				SLAdventures_SelectedAttackersList.AddForm(akActor)
			Else 
				akActor = none 
			EndIf
		EndWhile
	
		If (SLAdventures_SelectedAttackersList.GetSize() == 0)
			return SpawnActorsForRape(Player.GetCurrentLocation())
		Else 
			return SLAdventures_SelectedAttackersList
		EndIf
	EndIf
	
EndFunction

Bool Function IsValidAttacker(Actor akActor)

	If (akActor == none)
		return False
	EndIf
	
	If (akActor == Player) 
		return False
	EndIf

	If (SLA_Utility.IsSummonedActor(akActor) == True)
		return False
	EndIf
	
	If (akActor.IsDead() == True)
		return False
	EndIf
	
	If (akActor.IsDisabled() == True)
		return False
	EndIf
	
	If (bFollowersCanRape == False) && (akActor.IsInFaction(CurrentFollowerFaction) == True)
		return False
	EndIf
	
	Int Gender = Sexlab.GetGender(akActor)
	If (Gender == 1) && (sRapeAttackersGender == "Male")
		return False
	ElseIf (Gender == 0) && (sRapeAttackersGender == "Female")
		return False
	ElseIf (akActor.HasKeyword(ActorTypeAnimal) == True) && (bAllowAnimals == False) || ((akActor.GetActorBase().GetRace() == ChickenRace) || (akActor.GetActorBase().GetRace() == HareRace))
		return False
	ElseIf (bAllowCreatures == False)
		return False
	EndIf
	
	return True
	
EndFunction

FormList Function SpawnActorsForRape(Location akLocation)

	FormList akFormList 	;FormList containing the appropriate Base Actors to spawn
	FormList akFormListBoss	;For the Boss i.e. the first actor
	Bool bBanditsEitherGender = False	;This tells us whether bandits are attacking the player and we should alternate between genders
	;Bool bColdClimate = False
	;Bool bColdClimateAnimals = False
	Int iNumRapists = Utility.RandomInt(iMinimumSpawn, iMaximumSpawn)
	Int index 
	
	;Todo increase variety
	
	If (akLocation != none) && (akLocation.HasKeyWord(LocTypeDraugrCrypt)) && (bAllowCreatures == True)
		akFormList = SLAdventures_DraugrActorBaseList
		akFormListBoss = SLAdventures_DraugrBossActorBaseList
		SpawnedActors = CREATURES
	ElseIf (akLocation != none) && (akLocation.HasKeyWord(LocTypeFalmerHive)) && (bAllowCreatures == True)
		akFormList = SLAdventures_FalmerActorBaseList
		akFormListBoss = SLAdventures_FalmerBossActorBaseList
		SpawnedActors = CREATURES
	ElseIf (akLocation != none) && (bAllowCreatures == True) && (((akLocation.HasKeyword(LocTypeDungeon)) && (Utility.RandomInt(1,10) <= 5)) || (Utility.RandomInt(1,10) <= 1))
		akFormList = SLAdventures_TrollActorBaseList
		akFormListBoss = SLAdventures_TrollActorBaseList
		SpawnedActors = CREATURES
	ElseIf (bAllowAnimals == True) && (Utility.RandomInt(1,10) <= 3)
		akFormList = SLAdventures_WolfActorBaseList
		akFormListBoss = SLAdventures_WolfActorBaseList
		SpawnedActors = ANIMALS
	ElseIf (bAllowAnimals == True) && (Utility.RandomInt(1,10) <= 1)
		akFormList = SLAdventures_BearActorBaseList
		akFormListBoss = SLAdventures_BearActorBaseList
		SpawnedActors = ANIMALS
	ElseIf (ProximityRape.sRapeAttackersGender == "Male")
		akFormList = SLAdventures_BanditActorBaseListM
		akFormListBoss = SLAdventures_BanditBossActorBaseListM
		SpawnedActors = NPCS
	ElseIf (ProximityRape.sRapeAttackersGender == "Female")
		akFormList = SLAdventures_BanditActorBaseListF
		akFormListBoss = SLAdventures_BanditBossActorBaseListF
		SpawnedActors = NPCS
	ElseIf (ProximityRape.sRapeAttackersGender == "Either")
		bBanditsEitherGender = True
		If (Utility.RandomInt(1, 2) == 1)
			akFormListBoss = SLAdventures_BanditBossActorBaseListM
		Else
			akFormListBoss = SLAdventures_BanditBossActorBaseListF
		EndIf
		SpawnedActors = NPCS
	EndIf
	
	SLAdventures_SpawnedAttackersList.Revert()
	Actor akActor = Player.PlaceActorAtMe(akFormListBoss.GetAt(Utility.RandomInt(0, akFormListBoss.GetSize() - 1)) as ActorBase)
	akActor.AddSpell(SLAdventures_SleepRapeCalmSpell)
	SLAdventures_SpawnedAttackersList.AddForm(akActor)
	index = 1
		
	While (index < iNumRapists)
		If (bBanditsEitherGender == True)
			If (Utility.RandomInt(1, 2) == 1)
				akFormList = SLAdventures_BanditActorBaseListM
			Else
				akFormList = SLAdventures_BanditActorBaseListF
			EndIf
		EndIf
		akActor = Player.PlaceActorAtMe(akFormList.GetAt(Utility.RandomInt(0, akFormList.GetSize() - 1)) as ActorBase)
		akActor.AddSpell(SLAdventures_SleepRapeCalmSpell)
		SLAdventures_SpawnedAttackersList.AddForm(akActor)
		index += 1
	EndWhile
	
	return SLAdventures_SpawnedAttackersList
	
EndFunction

Function ClearAttackerFormList(FormList Attackers)

	If (Attackers == SLAdventures_SpawnedAttackersList) 
		Int index = Attackers.GetSize()
		While (index > 0)
			index -= 1
			Form akForm = Attackers.GetAt(index)
			Actor akActor = akForm as Actor
			If (akActor != none)
				akActor.Disable()
				akActor.Delete()
			EndIf
		EndWhile
	EndIf
	Attackers.Revert()

EndFunction

Function AfterRape(Actor[] Rapists, Bool InCity)

	If (InCity == True)
		If (SLA_Utility.HasNPCs(Rapists) == True)
			Int index = 0
			Actor akGuard = none
		
			While (index < Rapists.Length) && (Rapists[index] != none) && (akGuard == none)
				If (Rapists[index].IsGuard() == True)
					akGuard = Rapists[index]
				EndIf
				index += 1
			EndWhile
		
			Int[] Scenarios = new Int[5]
	
			If (akGuard != none)
				Scenarios[0] = iAfterRapeImprisonmentChance
			Else
				Scenarios[0] = 0
			EndIf
			If (DLCModsComp.bSimpleSlaveryIsLoaded == True)
				Scenarios[1] = iAfterRapeSimpleSlaveryChance
			Else
				Scenarios[1] = 0
			EndIf
			Scenarios[2] = iAfterRapeRobberyChance 
			Scenarios[3] = iAfterRapeSlutCoinChance
			Scenarios[4] = iAfterRapeLeftAloneChance
		
			Int Result = Utility.RandomInt(0, Scenarios[0] + Scenarios[1] + Scenarios[2] + Scenarios[3] + Scenarios[4] - 1)
		
			If (Result < Scenarios[0])
				PayBountyOrJailPlayer(akGuard)
			ElseIf (Result < Scenarios[0] + Scenarios[1])
				SimpleSlaveryEntry()
			ElseIf (Result < Scenarios[0] + Scenarios[1] + Scenarios[2])
				RobPlayer(Rapists.Length > 1)
			ElseIf (Result < Scenarios[0] + Scenarios[1] + Scenarios[2] + Scenarios[3])
				SlutCoin(Rapists.Length * 3)
			EndIf
		EndIf
	Else
		EscapeFromRape()		
	EndIf

EndFunction

Function RobPlayer(Bool MultipleAttackers = False, Bool Silently = False)
	
	If (MultipleAttackers == True) && (Silently == False)
		Debug.Notification("Your attackers help themselves with your inventory...")
	Else
		Debug.Notification("Your attacker helps themselves with your inventory...")
	EndIf
	
	If (bRobAllItems == True)
		Player.RemoveAllItems(abRemoveQuestItems = bRobberyRobQuestItems)
	Else
		If (bRobAllGold == True) 
			Player.RemoveItem(Gold001, Player.GetItemCount(Gold001), True)
		EndIf
		If (bRobRandomItems == True)
			Int ItemsStolen = 0
			Bool Break = False
			Int Attempts = 0
			Bool ItemFound = False
			Form akItem = none
	
			While (ItemsStolen < iItemsToRob) && (Break == False)
				ItemFound = False
				While (Attempts < 5) && (ItemFound == False)
					akItem = SLA_Utility.GetRandomItemFromContainer(Player as ObjectReference)
					If (akItem != none)
						If (Player.IsEquipped(akItem) == False) && (SLA_Utility.IsQuestItem(akItem) == False)
							If (akItem == Gold001) 
								Player.RemoveItem(akItem, Utility.RandomInt(10, 50), True)
							Else
								Player.RemoveItem(akItem, 1, True)
							EndIf
							ItemsStolen += 1
							ItemFound = True
						Else
							Attempts += 1
							If (Attempts >= 5)
								;After 5 consecutive failed attempts we are going to assume the player has no valid items left in their inventory.
								Break = True	
							EndIf
						EndIf
					Else
						;Player has no items left in their inventory
						Attempts = 5
						Break = True
					EndIf
				EndWhile
				Attempts = 0
			EndWhile
		EndIf
	EndIf
	
EndFunction  

Function PayBountyOrJailPlayer(Actor akGuard)
	
	Int iPlayerGold = Player.GetItemCount(Gold001)
	Faction akFaction = SLA_Utility.GetCurrentCrimeFaction(Player as ObjectReference)
	
	If (SLA_Utility.PayCrimeGold(akFaction, iPlayerGold) > 0)
		Debug.Notification("Unable to pay your bounty, you are arrested by the guard...")
		If (DLCModsComp.bPOPIsLoaded == True)
			Int iFaction = SLA_Utility.GetCurrentCrimeFactionAsInt(Player as ObjectReference)
			akGuard.SendModEvent("xpoArrestPC", "", 0)
		Else
			akFaction.SendPlayerToJail()
		EndIf
	Else
		Debug.Notification("The guard forces you to pay your bounty.")
	EndIf
	
EndFunction 

Function SlutCoin(Int Pieces) 
	
	Debug.Notification("Your attackers throw some money on the ground for you to collect.")
	While (Pieces > 0)
		Player.Additem(SLA_Utility.Gold001, 1, True)
		Player.DropObject(SLA_Utility.Gold001, 1)
		Pieces -= 1
	EndWhile 
	
EndFunction

Function SimpleSlaveryEntry()
	
	Debug.Notification("Unable to defend yourself, your attackers kidnap you and sell you into slavery...")
	Utility.Wait(2.0)
	SendModEvent("SSLV Entry")
	
EndFunction 

Function EscapeFromRape()

	; Move Player to the current hold capital
	; between 23:00 and 3:00 upon arrival
	; But make at least 8 hours pass
	; If no hold could be found, pick a random one
	; Todo Raven Rock / Solstheim
	
	RobPlayer(Silently = True)
	Location akLocation = Player.GetCurrentLocation()
	
	Bool MovedSomewhere = False
	
	If (akLocation != none)
		If (akLocation == WhiterunHoldLocation) || (WhiterunHoldLocation.IsChild(akLocation))
			EscapeToWhiterun()
			MovedSomewhere = True
		ElseIf (akLocation == EastMarchHoldLocation) || (EastMarchHoldLocation.IsChild(akLocation))
			EscapeToWindhelm()
			MovedSomewhere = True
		ElseIf (akLocation == FalkreathHoldLocation) || (FalkreathHoldLocation.IsChild(akLocation))
			EscapeToFalkreath()
			MovedSomewhere = True
		ElseIf (akLocation == ReachHoldLocation) || (ReachHoldLocation.IsChild(akLocation))
			EscapeToMarkarth()
			MovedSomewhere = True
		ElseIf (akLocation == RiftHoldLocation) || (RiftHoldLocation.IsChild(akLocation))
			EscapeToRiften()
			MovedSomewhere = True
		ElseIf (akLocation == PaleHoldLocation) || (PaleHoldLocation.IsChild(akLocation))
			EscapeToDawnstar()
			MovedSomewhere = True
		ElseIf (akLocation == HaafingarHoldLocation) || (HaafingarHoldLocation.IsChild(akLocation))
			EscapeToSolitude()
			MovedSomewhere = True
		ElseIf (akLocation == HjaalMarchHoldLocation) || (HjaalMarchHoldLocation.IsChild(akLocation))
			EscapeToMorthal()
			MovedSomewhere = True
		ElseIf (akLocation == WinterholdHoldLocation) || (WinterholdHoldLocation.IsChild(akLocation))
			EscapeToWinterhold()
			MovedSomewhere = True
		EndIf
	EndIf 
	
	If (MovedSomewhere == False)
		;Fallback - Random Location
		Int Destination = Utility.RandomInt(1, 9)
		If (Destination == 1)
			EscapeToWindhelm()
		ElseIf (Destination == 2)
			EscapeToFalkreath()
		ElseIf (Destination == 3)
			EscapeToMarkarth()
		ElseIf (Destination == 4)
			EscapeToSolitude()
		ElseIf (Destination == 5)
			EscapeToMorthal()
		ElseIf (Destination == 6)
			EscapeToDawnstar()
		ElseIf (Destination == 7)
			EscapeToRiften()
		ElseIf (Destination == 8) 
			EscapeToWinterhold()
		Else
			EscapeToWhiterun()
		EndIf
	EndIf
	
	Float TimeOfDay = SLA_Utility.GetTimeOfDay()
	Float Difference = 23.00 - TimeOfDay
	If (Difference > 0)
		SLA_Utility.AdvanceGameClock(Difference + Utility.RandomFloat(1.0, 2.0))
	Else
		SLA_Utility.AdvanceGameClock(24.0 + Utility.RandomFloat(1.0, 2.0))
	EndIf
	Debug.Notification("You somehow managed to escape your predicament.")

EndFunction

; We need to use Game.GetForm() in these functions because 
; adding the ObjectReferences as properties directly caused problems

Function EscapeToWhiterun()
	Player.MoveTo(Game.GetForm(WHITERUN_COC_MARKER_ID) as ObjectReference)
EndFunction

Function EscapeToWindhelm()
	Player.MoveTo(Game.GetForm(WINDHELM_COC_MARKER_ID) as ObjectReference)
EndFunction

Function EscapeToFalkreath()
	Player.MoveTo(Game.GetForm(FALKREATH_COC_MARKER_ID) as ObjectReference)
EndFunction

Function EscapeToMarkarth()
	Player.MoveTo(Game.GetForm(MARKARTH_COC_MARKER_ID) as ObjectReference)
EndFunction

Function EscapeToSolitude()
	Player.MoveTo(Game.GetForm(SOLITUDE_COC_MARKER_ID) as ObjectReference)
EndFunction

Function EscapeToMorthal()
	Player.MoveTo(Game.GetForm(MORTHAL_COC_MARKER_ID) as ObjectReference)
EndFunction

Function EscapeToDawnstar()
	Player.MoveTo(Game.GetForm(DAWNSTAR_COC_MARKER_ID) as ObjectReference)
EndFunction

Function EscapeToRiften()
	Player.MoveTo(Game.GetForm(RIFTON_COC_MARKER_ID) as ObjectReference)
EndFunction

Function EscapeToWinterhold()
	Player.MoveTo(Game.GetForm(WINTERHOLD_COC_MARKER_ID) as ObjectReference)
EndFunction

Function SaveMCMOptions(String FileName) 

	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeSleepEnabled", bRapeSleepEnabled)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeAlwaysSleepNaked", bRapeAlwaysSleepNaked)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeChanceSleepCity", iRapeChanceSleepCity)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeChanceSleepDungeon", iRapeChanceSleepDungeon)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeChanceSleepWilderness", iRapeChanceSleepWilderness)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, "RapeSleepModNaked", fRapeSleepModNaked)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, "RapeSleepModAroused", fRapeSleepModAroused)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, "RapeSleepModDrunk", fRapeSleepModDrunk)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeSleepMaxAttackers", iMaximumSpawn)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeSleepMinSpawn", iMinimumSpawn)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeSleepFollowerRape", bSleepAllowFollowerRape)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeSleepAllowAnimals", bAllowAnimals)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeSleepAllowCreatures", bAllowCreatures)
	
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "SleepRapeScenarioRobberyChance", iAfterRapeRobberyChance)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "SleepRapeScenarioSimpleSlaveryChance", iAfterRapeSimpleSlaveryChance)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "SleepRapeScenarioJailedChance", iAfterRapeImprisonmentChance)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "SleepRapeScenarioSlutCoin", iAfterRapeSlutCoinChance)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "SleepRapeScenarioNone", iAfterRapeLeftAloneChance)
	
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "SleepRapeAfterRobAllItems", bRobAllItems)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "SleepRapeAfterRobAllGold", bRobAllGold)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "SleepRapeAfterRobRandomItems", bRobRandomItems)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "SleepRapeAfterRobQuestItems", bRobberyRobQuestItems)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "SleepRapeAfterRobItemsToRob", iItemsToRob)
	
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "SleepRapeFollowersCanRape", bFollowersCanRape)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "SleepRapeFollowersCanPreventRape", bFollowersCanPreventRape)

EndFunction

Function LoadMCMOptions(String FileName)

	bRapeSleepEnabled = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeSleepEnabled")
	
	If (bRapeSleepEnabled == True) 
		RegisterForSleep()
	Else 
		UnRegisterForSleep()
	EndIf
	
	bRapeAlwaysSleepNaked = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeAlwaysSleepNaked")
	iRapeChanceSleepCity = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeChanceSleepCity", 0, 100)
	iRapeChanceSleepDungeon = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeChanceSleepDungeon", 0, 100)
	iRapeChanceSleepWilderness = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeChanceSleepWilderness", 0, 100)
	fRapeSleepModNaked = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, "RapeSleepModNaked", 0.0, 5.0, 0.1)
	fRapeSleepModAroused = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, "RapeSleepModAroused", 0.0, 5.0, 0.1)
	fRapeSleepModDrunk = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, "RapeSleepModDrunk", 0.0, 5.0, 0.1)
	iMaximumSpawn = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeSleepMaxAttackers", 1, 10)
	iMinimumSpawn = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeSleepMinSpawn", 1, iMaximumSpawn)
	bSleepAllowFollowerRape = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeSleepFollowerRape")
	bAllowAnimals = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeSleepAllowAnimals")
	bAllowCreatures = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeSleepAllowCreatures")
	
	iAfterRapeRobberyChance = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "SleepRapeScenarioRobberyChance", 0, 100)
	iAfterRapeSimpleSlaveryChance = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "SleepRapeScenarioSimpleSlaveryChance", 0, 100)
	iAfterRapeImprisonmentChance = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "SleepRapeScenarioJailedChance", 0, 100)
	iAfterRapeSlutCoinChance = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "SleepRapeScenarioSlutCoin", 0, 100)
	iAfterRapeLeftAloneChance = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "SleepRapeScenarioNone", 0, 100)

	bRobAllItems = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "SleepRapeAfterRobAllItems")
	bRobAllGold = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "SleepRapeAfterRobAllGold")
	bRobRandomItems = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "SleepRapeAfterRobRandomItems")
	bRobberyRobQuestItems = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "SleepRapeAfterRobQuestItems")
	iItemsToRob = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "SleepRapeAfterRobItemsToRob", 1, 20)
	
	bFollowersCanRape = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "SleepRapeFollowersCanRape")
	bFollowersCanPreventRape = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "SleepRapeFollowersCanPreventRape")
	
EndFunction 

Int SpawnedActors = 0
Actor Property Player Auto 
Idle Property WakeUpIdle Auto 
SLAdventures_MCM_Script Property MCM Auto 
SLAdventures_Utility Property SLA_Utility Auto 
SLAdventures_PlayerSexTracker Property PlayerSexTracker Auto 
SLAdventures_SleepCreepScript Property SleepCreep Auto  
SLAdventures_CrimeScript Property Crime Auto 
SexLabFramework Property Sexlab Auto 
slaframeworkscr Property Aroused Auto 
SLAdventures_DLCAndModCompScript Property DLCModsComp Auto 
SLAdventures_GangRapeController Property RapeController Auto 
SLAdventures_ProximityRapeScript Property ProximityRape Auto 
FormList Property SLAdventures_SelectedAttackersList Auto 
FormList Property SLAdventures_SpawnedAttackersList Auto 
Keyword Property LocTypeFalmerHive Auto 
Keyword Property LocTypeDraugrCrypt Auto 
Keyword Property LocTypeDungeon Auto 
Keyword Property ActorTypeAnimal Auto 
Spell Property SLAdventures_SleepRapeCalmSpell Auto 
MiscObject Property Gold001 Auto 
Race Property ChickenRace Auto 
Race Property HareRace Auto 

FormList Property SLAdventures_BanditBossActorBaseListM Auto 
FormList Property SLAdventures_BanditBossActorBaseListF Auto 
FormList Property SLAdventures_BanditActorBaseListM Auto 
FormList Property SLAdventures_BanditActorBaseListF Auto 
FormList Property SLAdventures_DraugrBossActorBaseList Auto 
FormList Property SLAdventures_DraugrActorBaseList Auto 
FormList Property SLAdventures_FalmerActorBaseList Auto 
FormList Property SLAdventures_FalmerBossActorBaseList Auto 
FormList Property SLAdventures_WolfActorBaseList Auto 
FormList Property SLAdventures_TrollActorBaseList Auto 
FormList Property SLAdventures_BearActorBaseList Auto 

Location Property WhiterunHoldLocation Auto 
Location Property EastMarchHoldLocation Auto 
Location Property FalkreathHoldLocation Auto 
Location Property ReachHoldLocation Auto 
Location Property RiftHoldLocation Auto 
Location Property PaleHoldLocation Auto 
Location Property HaafingarHoldLocation Auto 
Location Property HjaalMarchHoldLocation Auto 
Location Property WinterholdHoldLocation Auto 
Static Property XMarker Auto
Faction Property CurrentFollowerFaction Auto 

Bool Property bRapeSleepEnabled = True Auto Hidden
Bool Property bRapeAlwaysSleepNaked = True Auto Hidden 
Int Property iRapeChanceSleepCity = 5 Auto Hidden
Int Property iRapeChanceSleepDungeon = 50 Auto Hidden
Int Property iRapeChanceSleepWilderness = 30 Auto Hidden
Float Property fRapeSleepModNaked = 1.5 Auto Hidden
Float Property fRapeSleepModAroused = 1.5 Auto Hidden
Float Property fRapeSleepModDrunk = 1.5 Auto Hidden 
Int Property iMaximumSpawn = 5 Auto Hidden 
Int Property iMinimumSpawn = 1 Auto Hidden 
Bool Property bSleepAllowFollowerRape = False Auto Hidden 
Bool Property bAllowAnimals = False Auto Hidden 
Bool Property bAllowCreatures = False Auto Hidden 
String Property sRapeAttackersGender = "Male" Auto Hidden 
Bool Property bFollowersCanRape = False Auto Hidden 
Bool Property bFollowersCanPreventRape = False Auto Hidden 

Bool Property bRobAllItems = False Auto Hidden 			
Bool Property bRobAllGold = False Auto Hidden 			
Bool Property bRobRandomItems = True Auto Hidden 		
Bool Property bRobberyRobQuestItems = False Auto Hidden 
Int Property iItemsToRob = 5 Auto Hidden 				

Int Property iAfterRapeRobberyChance = 0 Auto Hidden 
Int Property iAfterRapeSimpleSlaveryChance = 0 Auto Hidden 
Int Property iAfterRapeImprisonmentChance = 0 Auto Hidden
Int Property iAfterRapeSlutCoinChance = 0 Auto Hidden 
Int Property iAfterRapeLeftAloneChance = 100 Auto Hidden 

Int Property NPCS = 10 AutoReadOnly 
Int Property ANIMALS = 20 AutoReadOnly 
Int Property CREATURES = 30 AutoReadOnly 

;Whiterun
Int Property WHITERUN_COC_MARKER_ID = 0x00108D8D AutoReadOnly

;Windhelm
Int Property WINDHELM_COC_MARKER_ID = 0x000B0EF6 AutoReadOnly

;Falkreath
Int Property FALKREATH_COC_MARKER_ID = 0x000A6BEB AutoReadOnly

;Markarth
Int Property MARKARTH_COC_MARKER_ID = 0x000B09FE AutoReadOnly

;Riften
Int Property RIFTON_COC_MARKER_ID = 0x000AA0BF AutoReadOnly

;Dawnstar
Int Property DAWNSTAR_COC_MARKER_ID = 0x0009F270 AutoReadOnly

;Solitude
Int Property SOLITUDE_COC_MARKER_ID = 0x000D071A AutoReadOnly

;Morthal
Int Property MORTHAL_COC_MARKER_ID = 0x000EB7CC AutoReadOnly

;Winterhold
Int Property WINTERHOLD_COC_MARKER_ID = 0x000EB7E3 AutoReadOnly 