Scriptname SLAdventures_Utility extends Quest 

;Events

Event SuspendDDHelpless(string eventName, string strArg, float numArg, Form sender)
	bDDHelplessSuspend = True
	iLastFormSuspendDDHelpless = sender.GetFormID()
EndEvent 

Event ResumeDDHelpless(string eventName, string strArg, float numArg, Form sender)
	bDDHelplessSuspend = False
EndEvent 

;Functions

Function RegisterDeviouslyHelplessEvents()
	;Some mods use these events to prevent rape attacks by Deviously Helpless and we can catch them to prevent Rape and Crime as well.
	RegisterForModEvent("dhlp-Suspend", "SuspendDDHelpless")
	RegisterForModEvent("dhlp-Resume", "ResumeDDHelpless")
EndFunction

Float Function GetTimeOfDay()
	
	float fTime = Utility.GetCurrentGameTime()
	fTime = fTime - (Math.floor(fTime))
	fTime = fTime * 24
	
	Return fTime
	
EndFunction 

Function AdvanceGameClock(Float akAmount)
	GameHour.Mod(akAmount)
EndFunction 

;/Bool Function IsEncumbered(Actor akActor) This does not work with the Poverty Perk

	If akActor.GetActorValue("InventoryWeight") > akActor.GetActorValue("CarryWeight")
		return True
	Else
		return False
	EndIf
	
EndFunction /;

Bool Function IsNight()

	float fTime = GetTimeOfDay()
	If ((fTime > fDusk) || (fTime < fDawn))
		return True
	Else 
		return False
	EndIf 
	
EndFunction 

Bool Function IsInCity(Actor akActor)

	Location akLocation = akActor.GetCurrentLocation()
	If (akLocation == none)
		return False
	ElseIf (akLocation.HasKeyWord(LocTypeCity))
		return True
	ElseIf (akLocation.HasKeyWord(LocTypeTown))
		return True 
	EndIf
	
	Return False
	
EndFunction

Bool Function IsInCityOrHabitation(Actor akActor)

	Location akLocation = akActor.GetCurrentLocation()
	If (akLocation == none)
		return False
	ElseIf (akLocation.HasKeyWord(LocTypeJail))
		return False
	ElseIf (akLocation.HasKeyWord(LocTypeCity))
		return True
	ElseIf (akLocation.HasKeyWord(LocTypeTown))
		return True 
	ElseIf (akLocation.HasKeyWord(LocTypeDwelling))
		return True
	ElseIf (akLocation.HasKeyWord(LocTypeHabitation))
		return True 
	ElseIf (akLocation.HasKeyWord(LocTypeInn))
		return True
	EndIf
	
	Return False
	
EndFunction 

Bool Function IsTavern(Location akLocation)

	If (akLocation == none)
		return False
	ElseIf (akLocation.HasKeyWord(LocTypeInn))
		return True
	EndIf
	
	Return False
	
EndFunction 

Bool Function IsStore(Location akLocation)

	If (akLocation == none)
		return False
	ElseIf (akLocation.HasKeyWord(LocTypeStore))
		return True
	EndIf
	
	Return False
	
EndFunction 

Bool Function IsTemple(Location akLocation)

	If (akLocation == none)
		return False
	ElseIf (akLocation.HasKeyWord(LocTypeTemple))
		return True
	EndIf
	
	Return False
	
EndFunction

Bool Function IsGuild(Location akLocation)

	If (akLocation == none)
		return False
	ElseIf (akLocation.HasKeyWord(LocTypeGuild))
		return True
	EndIf
	
	Return False
	
EndFunction

Bool Function IsCastle(Location akLocation)

	If (akLocation == none)
		return False
	ElseIf (akLocation.HasKeyWord(LocTypeCastle))
		return True
	ElseIf (akLocation == WinterholdJarlsLonghouseLocation)
		return True
	EndIf
	
	Return False
	
EndFunction

Bool Function IsPlayerHome(Location akLocation)

	If (akLocation == none)
		return False
	ElseIf (akLocation.HasKeyWord(LocTypePlayerHouse))
		return True
	EndIf
	
	Return False
	
EndFunction

Bool Function IsSummonedActor(Actor akActor)

	If (akActor.HasKeyWord(MagicSummonFamiliar) == True) || (akActor.HasKeyWord(MagicSummonFire) == True) || (akActor.HasKeyWord(MagicSummonFrost) == True) || (akActor.HasKeyWord(MagicSummonShock) == True) || (akActor.HasKeyWord(MagicSummonUndead) == True) || (akActor.HasKeyWord(MGRitualSummon) == True)
		return True
	Else
		return False
	EndIf
	
EndFunction 

Bool Function HasNPCs(Actor[] akActors)

	Int index = 0
	While (index < akActors.Length) && (akActors[index] != none)
		If (akActors[index].HasKeyword(ActorTypeNPC))
			return True
		EndIf
	index += 1
	EndWhile
	
	return False
	
EndFunction 

Int Function CountNPCs(Actor[] akActors)

	Int Result = 0
	Int index = 0
	While (akActors[index] != none)
		If (akActors[index].HasKeyword(ActorTypeNPC))
			Result += 1
		EndIf
	index += 1
	EndWhile
	
	return Result
	
EndFunction 

Float Function GetHoursPassed(float Since, float Now = 0.0)
	;Returns the number of hours (as float) passed between two given points of game time. 
	;"Now" defaults to the current game time.

	If (Now == 0.0)
		Now = Utility.GetCurrentGameTIme()
	EndIf 
	float fHoursPassed = (Now - Since) * 24
	Return fHoursPassed
	
EndFunction 

Bool Function IsQuestItem(Form akForm)
	
	;Return the Item is a quest item if it is a reference.
	;This should catch all quest items, inlcuding DLC and mod added, but might return false positives in some cases.
	If (akForm as ObjectReference != none)
		return True
	Else 
		return False
	EndIf
	
EndFunction 

Form Function GetRandomItemFromContainer(ObjectReference akContainer)
	
	Int ItemCount = akContainer.GetNumItems()
	return akContainer.GetNthForm(Utility.RandomInt(0, ItemCount - 1))
	
EndFunction 

Bool Function IsThane(Int iFaction = -1)
;Is the player Thane in the current Location?

	If (iFaction == -1)
		iFaction = GetCurrentCrimeFactionAsInt(Game.GetPlayer() as ObjectReference)
	EndIf
	
	If (iFaction == 0)
		If (Favors.WhiterunImpGetOutofJail > 0) || (Favors.WhiterunSonsGetOutofJail > 0)
			return True
		EndIf
	Elseif (iFaction == 1)
		If (Favors.EastmarchImpGetOutofJail > 0) || (Favors.EastmarchSonsGetOutofJail > 0)
			return True
		EndIf
	Elseif (iFaction == 2)
		If (Favors.WinterholdImpGetOutofJail > 0) || (Favors.WinterholdSonsGetOutofJail > 0)
			return True
		EndIf
	Elseif (iFaction == 3)
		If (Favors.FalkreathImpGetOutofJail > 0) || (Favors.FalkreathSonsGetOutofJail > 0)
			return True
		EndIf
	Elseif (iFaction == 4)
		If (Favors.HaafingarImpGetOutofJail > 0) || (Favors.HaafingarSonsGetOutofJail > 0)
			return True
		EndIf
	Elseif (iFaction == 5)
		If (Favors.HjaalmarchImpGetOutofJail > 0) || (Favors.HjaalmarchSonsGetOutofJail > 0)
			return True
		EndIf
	Elseif (iFaction == 6)
		If (Favors.PaleImpGetOutofJail > 0) || (Favors.PaleSonsGetOutofJail > 0)
			return True
		EndIf
	Elseif (iFaction == 7)
		If (Favors.ReachImpGetOutofJail > 0) || (Favors.ReachSonsGetOutofJail > 0)
			return True
		EndIf
	ElseIf (iFaction == 8)
		If (Favors.RiftImpGetoutofJail > 0) || (Favors.RiftSonsGetOutofJail > 0)
			return True
		EndIf
	EndIf
	
	;If Player is not Thane or is in Raven Rock or another Location that does not have Thaneship
	return False	
	
EndFunction

Faction Function GetCurrentCrimeFaction(ObjectReference Reference)

	Int index = 0
	While (index <= 9)
		
		If (Reference.IsInLocation((SLAdventures_HoldsList.GetAt(index))as Location) == True)
			Return (SLAdventures_ValidCrimeFactions.GetAt(index) as Faction)
		EndIf 
		
		index += 1
	EndWhile 
	return none 	;Failsafe if not in a valid location 

EndFunction 

Int Function GetCurrentCrimeFactionAsInt(ObjectReference Reference)

	Int index = 0
	While (index <= 9)
		
		If (Reference.IsInLocation((SLAdventures_HoldsList.GetAt(index))as Location) == True)
			Return index
		EndIf 
		
		index += 1
	EndWhile 
	return -1 	;Failsafe if not in a valid crime location

EndFunction 

Int Function PayCrimeGold(Faction akFaction, Int Amount)
	;Pays violent crime first, then non-violent crime. Returns the remaining bounty, if any.
	;Give -1 as Amount to clear the entire bounty.
	
	Int CrimeGoldViolent = akFaction.GetCrimeGoldViolent()
	Int CrimeGoldNonviolent = akFaction.GetCrimeGoldNonviolent()
	Actor Player = Game.GetPlayer() 
	
	If (Amount == -1)
		akFaction.ModCrimeGold(-CrimeGoldViolent, abViolent = True)
		akFaction.ModCrimeGold(-CrimeGoldNonviolent, abViolent = False)
		return 0
	EndIf
	
	If (Amount >= CrimeGoldViolent)
		akFaction.ModCrimeGold(-CrimeGoldViolent, abViolent = True)
		Amount -= CrimeGoldViolent
		Player.RemoveItem(Gold001, CrimeGoldViolent, False)		
		
		If (Amount >= CrimeGoldNonviolent)
			akFaction.ModCrimeGold(-CrimeGoldNonviolent, abViolent = False)
			Player.RemoveItem(Gold001, CrimeGoldNonviolent, False)
		Else
			akFaction.ModCrimeGold(-Amount, abViolent = False)
			Player.RemoveItem(Gold001, Amount, False)
		EndIf

	Else
		akFaction.ModCrimeGold(-Amount, abViolent = True)
		Player.RemoveItem(Gold001, Amount, False)
	EndIf
	
	CrimeGoldViolent = akFaction.GetCrimeGoldViolent()
	CrimeGoldNonviolent = akFaction.GetCrimeGoldNonviolent()
	
	return (CrimeGoldViolent + CrimeGoldNonviolent)
	
EndFunction

Bool Function IsAnyMenuOpen()
	;Todo remove This
	return UI.IsTextInputEnabled()
EndFunction



;Variables and Properties - no functions after this line 

;Properties 
Float Property fDusk = 19.00 Auto Hidden
Float Property fDawn = 5.00 Auto Hidden
Bool Property bDDHelplessSuspend = False Auto Hidden
Int Property iLastFormSuspendDDHelpless = 0 Auto Hidden ;The FormID of the Form that last sent the DD Helpless suspend event. It is in decimal and needs to be converted manually.  

SexLabFramework Property Sexlab Auto 
SLAdventures_SexDiary Property SexDia Auto
SLAdventures_RapeScript Property Rape Auto 
SLAdventures_MCM_Script Property MCM Auto 
FavorJarlsMakeFriendsScript Property Favors Auto  

Faction Property SLAdventures_CurrentPartnersFaction Auto
Faction Property SLAdventures_SexPartnersFaction Auto  
FormList Property SLAdventures_ValidCrimeFactions Auto 
FormList Property SLAdventures_HoldsList Auto 

Keyword Property MagicSummonFamiliar Auto 
Keyword Property MagicSummonFire Auto
Keyword Property MagicSummonFrost Auto
Keyword Property MagicSummonShock Auto
Keyword Property MagicSummonUndead Auto
Keyword Property MGRitualSummon Auto

Keyword Property LocTypeCity Auto 
Keyword Property LocTypeTown Auto 
Keyword Property LocTypeDwelling Auto 
Keyword Property LocTypeHabitation Auto 
Keyword Property LocTypeJail Auto

Keyword Property LocTypeInn Auto 
Keyword Property LocTypeTemple Auto 
Keyword Property LocTypeStore Auto 
Keyword Property LocTypeGuild Auto 
Keyword Property LocTypeCastle Auto 
Keyword Property LocTypePlayerHouse Auto 
MiscObject Property Gold001 Auto 
Keyword Property ActorTypeNPC Auto 

Location Property WinterholdJarlsLonghouseLocation Auto 
GlobalVariable Property GameHour Auto 

Spell Property SLAdventures_MasturbateRestoreHealth Auto 
Spell Property SLAdventures_MasturbateRestoreMagicka Auto 
Spell Property SLAdventures_MasturbateRestoreStamina Auto 


;Deprecated - These functions and properties will be removed in a future version of Sexlab Adventures.

Event SexlabSceneStart(Int tid, Bool HasPlayer)
EndEvent 

Event SexlabSceneEnd(Int tid, Bool HasPlayer)
EndEvent 

Function RegisterSexlab()
EndFunction 

;Int Property iPlayerHasSex = 0 	Auto Hidden ´
;Bool Property bPlayerIsRaped = False Auto Hidden
;Float Property fAfterSex = 0.0 Auto Hidden