Scriptname SLAdventures_ZazLoaderScript extends Quest 
;Script to handle ZaZ compatibility without adding a dependency

Event OnInit()

	;debug.notification("Trying to load zbfSL!")
	RegisterForModEvent("SLAdv_ZazMasturbation", "OnZazMasturbationStart")
	RegisterForModEvent("SLAdv_ZazRape", "OnZazRapeStart")
	zbfSL = Game.GetFormFromFile(0xCD14, "ZaZAnimationPack.esm") as Quest
	;If (zbfSL != none)
		;debug.notification("zbfSL Loaded!")
	;EndIf
	
EndEvent 

Event OnZazMasturbationStart() 

	;debug.notification("OnZazMasturbationStart()")
	sslBaseAnimation[] Anims = GetBoundAnimationsFromZap(Player)
	Actor[] Player = new Actor[1]
	Player[0] = Game.GetPlayer()
	Sexlab.StartSex(Player, Anims, none, Player[0])
	
EndEvent 

Event OnZazRapeStart(Form Actor0, Form Actor1, Form Victim) 

	;debug.notification("OnZazRapeStart()")
	Actor[] akActors
	sslBaseAnimation[] Anim

	akActors = new Actor[2]
	akActors[0] = Actor0 as Actor
	akActors[1] = Actor1 as Actor
	
	Anim = GetBoundAnimationsFromZap(akActors)
	
	SexLab.StartSex(akActors, Anim, Victim as Actor, Victim as Actor, False)
	
EndEvent

;ZAP functions - pretty much copied from DCL
;Apparantly ZAP itself borks with SL 1.62
sslBaseAnimation[] Function GetBoundAnimationsFromZap(Actor[] akActors)

	zbfSexLabBaseEntry[] akEntries = (zbfSL as zbfSexLab).GetEntriesByTags(akActors)
	zbfSexLabBaseEntry Entry = (zbfSL as zbfSexLab).GetRandomEntry(akEntries)
	sslBaseAnimation Anim = None
	Int iActorCount = zbfUtil.CountActorList(akActors)
	anim = NewAnimation("ZapStartSex")			
	Int[] iBindTypes = GetBindTypes(akActors)
	(zbfSL as zbfSexLab).DefineAnimation(Entry, Anim, (zbfSL as zbfSexLab).GetSexLabAnimationNames(Entry, iBindTypes), abSaveAnim = False)	
	Anim.Save(-1)
	sslBaseAnimation[] Anims = new sslBaseAnimation[1]
	Anims[0] = Anim
	return Anims

EndFunction 

Int[] Function GetBindTypes(Actor[] akActors)

	Int[] BindTypes = New Int[4]
	Int iActor = akActors.Length
	While iActor > 0
		iActor -=1
		BindTypes[iActor] = (zbfSL as zbfSexLab).zbf.GetBindTypeFromWornKeywords(akActors[iActor])
	EndWhile
	Return BindTypes
	
EndFunction

sslBaseAnimation Function NewAnimation(String asModName)	
	sslBaseAnimation anim = None
	zbfSexLab Script = zbfSL as zbfSexLab
	Int index = Script.BorrowModNames.Find("")
	If index != -1
		Script.BorrowModNames[index] = asModName
		anim = Script.BorrowSlots[index]
		anim.Initialize()
	EndIf
	Return anim
EndFunction

;End of ZAP functions

Quest Property zbfSL Auto Hidden 
SexlabFramework Property Sexlab Auto 
